/*
 * $Id: FileUtil.java,v 1.4 2005/10/31 16:25:35 suhrbier Exp $
 * Created on 27.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: FileUtil.java,v $
 * Revision 1.4  2005/10/31 16:25:35  suhrbier
 * *** empty log message ***
 *
 * Revision 1.3  2005/10/28 23:36:11  suhrbier
 * RoleManager begonnen mit add.
 *
 * Revision 1.2  2005/10/28 10:03:33  suhrbier
 * PolicyManager completed bis auf Comment.
 *
 * Revision 1.1  2005/10/27 18:26:05  suhrbier
 * RBACPolicyFinderModule completed.
 *
 */
package nbi.util;

import java.io.File;
import java.io.FileFilter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.io.filefilter.DirectoryFileFilter;

/**
 * Collection of utility functions about Files.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.4 $
 * @since 
 */

public class FileUtil {
    public static final String currentDirectory = ".";
    public static List findSubDirectories(File dir)
    {
        List subDirs = Arrays.asList( dir.listFiles( (FileFilter)DirectoryFileFilter.INSTANCE));
        List result = new ArrayList(subDirs);
        Iterator subDirIt = subDirs.iterator();
        while( subDirIt.hasNext())
            result.addAll(findSubDirectories((File)subDirIt.next()));
        return result;
    }
}
