/*
 * $Id: PEPClientKeySelectorResult.java,v 1.3 2006/07/25 14:59:03 suhrbier Exp $
 * Created on 14.07.2006
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: PEPClientKeySelectorResult.java,v $
 * Revision 1.3  2006/07/25 14:59:03  suhrbier
 * update JavaDoc
 *
 * Revision 1.2  2006/07/24 17:31:09  suhrbier
 * update JavaDoc
 *
 * Revision 1.1  2006/07/14 21:17:58  suhrbier
 * Basis fr Validation gelegt (Trennen von Signature und Document).
 *
 */
package nbi.xmlsec;

import java.security.Key;

import javax.xml.crypto.KeySelectorResult;


/**
 * Implements the {@link KeySelectorResult KeySelectorResult} interface for the
 * method
 * {@link nbi.xmlsec.PEPClientKeySelector#select(javax.xml.crypto.dsig.keyinfo.KeyInfo, javax.xml.crypto.KeySelector.Purpose, javax.xml.crypto.AlgorithmMethod, javax.xml.crypto.XMLCryptoContext) PEPClientKeySelector.select(KeyInfo, Purpose, AlgorithmMethod, XMLCryptoContext)}.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.3 $
 * @since
 */

public class PEPClientKeySelectorResult implements KeySelectorResult {
    Key key = null;

    /**
     * Inits the KeySelectorResult.
     * 
     * @param key
     *            (Public)Key to be returned by {@link #getKey() getKey()}
     */
    public PEPClientKeySelectorResult(Key key) {
        super();
        this.key = key;
    }

    /**
     * @return The Public Key internally stored.
     * @see javax.xml.crypto.KeySelectorResult#getKey()
     */
    public Key getKey() {
        return key;
    }
}
