/*
 * $Id: PermitAllHostNameVerifier.java,v 1.2 2006/07/24 17:31:09 suhrbier Exp $
 * Created on 30.05.2006
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: PermitAllHostNameVerifier.java,v $
 * Revision 1.2  2006/07/24 17:31:09  suhrbier
 * update JavaDoc
 *
 * Revision 1.1  2006/05/30 19:05:35  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.SSLSession;

/**
 * Implements the {@link javax.net.ssl.HostnameVerifier HostNameVerifier} interface to permit connections to all hosts.
 * I.e., the {@link #verify(String, SSLSession) verify(String, SSLSession)} method always returns <code>true</code>.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since 
 */

public class PermitAllHostNameVerifier implements HostnameVerifier {

    /**
     *	Default constructor 
     */
    public PermitAllHostNameVerifier() {
        super();
    }

    /**
     * Permits all hosts.
     * @param arg0 Not inspected
     * @param arg1 Not inspected
     * @return Always returns <code>true</code>.
     * @see javax.net.ssl.HostnameVerifier#verify(java.lang.String, javax.net.ssl.SSLSession)
     */
    public boolean verify(String arg0, SSLSession arg1) {
        return true;
    }
}
