/*
 * $Id: ContentObject.java,v 1.2 2005/08/15 13:24:46 suhrbier Exp $
 * Created on 12.01.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: ContentObject.java,v $
 * Revision 1.2  2005/08/15 13:24:46  suhrbier
 * Zwischenspeicherung
 *
 * Revision 1.1  2005/03/07 18:22:29  suhrbier
 * Initiale Version
 *
 * Revision 1.2  2005/01/24 20:55:36  suhrbier
 * Response-Scannen komplett.
 *
 * Revision 1.1  2005/01/19 17:17:24  suhrbier
 * *** empty log message ***
 *
 * Revision 1.3  2005/01/18 12:03:24  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/01/17 17:37:23  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/01/12 11:13:56  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.biocase.protocol;

import org.apache.log4j.Logger;
import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;

/**
 * Base class for BioCASE content objects like {@link Scan Scan}or
 * {@link Capabilities Capabilities}
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since
 */

public class ContentObject extends ProtocolType {
	static Logger logger = Logger.getLogger(ContentObject.class);

	/**
	 * Inits this instance.
	 * 
	 * @param protocolURI
	 *            The protocol version of this instance.
	 */
	public ContentObject(String protocolURI) {
		super(protocolURI);
	}

	/**
	 * Should be overwritten to write the content object to a SAX Stream.
	 * 
	 * @param out
	 *            {@link ContentHandler ContentHandler}to write to.
	 * @throws SAXException
	 */
	public void write(ContentHandler out) throws SAXException {
	}
}
