/*
 * $Id: Document.java,v 1.2 2006/07/17 20:27:10 suhrbier Exp $
 * Created on 12.01.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: Document.java,v $
 * Revision 1.2  2006/07/17 20:27:10  suhrbier
 * Fehler behoben
 * + validate Diagnostics
 * Fehler beim parsen des ContentObject Documents !
 *
 * Revision 1.1  2006/07/17 10:24:18  suhrbier
 * Parsen von ContentObject ohne Filter als byte[].
 * Document neuer Typ von ContentObject.
 *
 * Revision 1.2  2005/08/15 21:58:55  suhrbier
 * Update of all Protocol Types finished.
 * Some tests are missing.
 *
 * Revision 1.1  2005/03/07 18:22:29  suhrbier
 * Initiale Version
 *
 * Revision 1.3  2005/01/20 14:37:32  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/01/19 17:17:24  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/01/12 11:13:57  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.biocase.protocol;

import java.io.UnsupportedEncodingException;


/**
 * This class wraps the BioCASE protocol content object of type Document.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since
 */
public class Document extends ContentObject {

    /** Buffer for the document data */
    private byte[] document;

    /**
     * Inits this instance.
     * 
     * @param protocolURI
     *            The protocol version of this instance.
     */
    public Document(String protocolURI) {
        super(protocolURI);
    }

    /**
     * Inits this instance.
     * 
     * @param protocolURI
     *            The protocol version of this instance.
     */
    public Document(String protocolURI, byte[] document) {
        super(protocolURI);
        this.document=document;
    }

    /**
     * Gets the document
     * @return Returns the document.
     */
    public byte[] getDocument() {
        return document;
    }
    /**
     * Sets document
     * @param document The document to set.
     */
    public void setDocument(byte[] document) {
        this.document = document;
    }
    
    public String toString() {
        String ret=System.getProperty("line.separator");
        try {
            ret += new String(document, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            logger.fatal("This should never happen: "+e.getMessage());
        }
        return ret;
    }
}
