/*
 * $Id: OperationType.java,v 1.5 2005/10/07 18:27:46 suhrbier Exp $
 * Created on 12.01.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: OperationType.java,v $
 * Revision 1.5  2005/10/07 18:27:46  suhrbier
 * Beginn Umbau XACML-Builder (4all PolicyTreeElements).
 *
 * Revision 1.4  2005/08/15 21:58:55  suhrbier
 * Update of all Protocol Types finished.
 * Some tests are missing.
 *
 * Revision 1.3  2005/08/10 20:57:12  suhrbier
 * Updated JavaDoc & Comments
 *
 * Revision 1.2  2005/08/06 23:28:44  suhrbier
 * Zwischenspeicherung
 *
 * Revision 1.1  2005/03/07 18:22:29  suhrbier
 * Initiale Version
 *
 * Revision 1.7  2005/02/11 17:48:07  suhrbier
 * Erste Verbindung BioCASE->PDP
 *
 * Revision 1.6  2005/01/20 14:44:07  suhrbier
 * *** empty log message ***
 *
 * Revision 1.5  2005/01/14 20:58:45  suhrbier
 * *** empty log message ***
 *
 * Revision 1.4  2005/01/14 18:13:41  suhrbier
 * *** empty log message ***
 *
 * Revision 1.3  2005/01/14 17:05:09  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/01/13 17:50:52  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/01/12 11:13:56  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.biocase.protocol;

import org.apache.log4j.Logger;
import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;

/**
 * Abstract base class of the BioCASE protocol treeElements scan and search operation type.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.5 $
 * @since
 */
public abstract class OperationType extends ProtocolType {
    static Logger logger = Logger.getLogger(OperationType.class);

    /** Attribute requestFormat used for all operation types */
    protected String requestFormat;

    /**
     * Inits this instance.
     * 
     * @param protocolURI
     *            The protocol version of this instance.
     */
    public OperationType(String protocolURI) {
        super(protocolURI);
    }

    /**
     * Writes the Operation type to a SAX Stream.
     * 
     * @param out
     *            {@link ContentHandler ContentHandler}to write to.
     * @throws SAXException
     */
    abstract public void write(ContentHandler out) throws SAXException;

    public String toString() {
        StringBuffer ret = new StringBuffer();
        ret.append("(");
        if (requestFormat != null)
            ret.append("requestFormat=" + requestFormat + ",");
        return ret.toString();
    }

    /**
     * Gets the request format.
     * 
     * @return The requestFormat.
     */
    public String getRequestFormat() {
        return requestFormat;
    }

    /**
     * Sets the request format.
     * 
     * @param requestFormat
     *            The requestFormat to set.
     */
    public void setRequestFormat(String requestFormat) {
        this.requestFormat = requestFormat;
    }
}
