/*
 * $Id: Operator.java,v 1.3 2005/10/07 18:27:46 suhrbier Exp $
 * Created on 12.01.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: Operator.java,v $
 * Revision 1.3  2005/10/07 18:27:46  suhrbier
 * Beginn Umbau XACML-Builder (4all PolicyTreeElements).
 *
 * Revision 1.2  2005/08/15 21:58:55  suhrbier
 * Update of all Protocol Types finished.
 * Some tests are missing.
 *
 * Revision 1.1  2005/08/07 16:15:31  suhrbier
 * Umstellung Request auf Filter
 *
 * Revision 1.1  2005/03/07 18:22:29  suhrbier
 * Initiale Version
 *
 * Revision 1.4  2005/01/17 15:37:52  suhrbier
 * *** empty log message ***
 *
 * Revision 1.3  2005/01/14 20:58:45  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/01/13 17:50:52  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/01/13 16:26:28  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/01/12 11:13:57  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.biocase.protocol;

import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;

/**
 * Abstract base class for the BioCASE protocol treeElements operator(filter) type.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.3 $
 * @since
 */
abstract public class Operator extends ProtocolType {

    /** operator type */
    String type;

    /**
     * Inits this instance.
     * 
     * @param protocolURI
     *            The protocol version of this instance.
     */
    public Operator(String protocolURI, String type) {
        super(protocolURI);
        this.type = type;
    }

    /**
     * Writes the Operation type to a SAX Stream.
     * 
     * @param out
     *            {@link ContentHandler ContentHandler}to write to.
     * @throws SAXException
     */
    abstract public void write(ContentHandler out) throws SAXException;
    
    public String toString() {
        StringBuffer ret = new StringBuffer();
        ret.append("(");
        if (type != null)
            ret.append("Type=" + type + ",");
        return ret.toString();
    }

    /**
     * Gets the type
     * 
     * @return Returns the type.
     */
    public String getType() {
        return type;
    }

    /**
     * Sets type
     * 
     * @param type
     *            The type to set.
     */
    public void setType(String type) {
        this.type = type;
    }
}
