/*
 * $Id: Request.java,v 1.4 2005/08/15 21:58:55 suhrbier Exp $
 * Created on 05.01.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: Request.java,v $
 * Revision 1.4  2005/08/15 21:58:55  suhrbier
 * Update of all Protocol Types finished.
 * Some tests are missing.
 *
 * Revision 1.3  2005/08/08 19:39:09  suhrbier
 * COP and LOPFilter tested.
 * ProtocolFilter enhancements.
 *
 * Revision 1.2  2005/08/06 22:08:28  suhrbier
 * Zwischenspeicherung
 *
 * Revision 1.1  2005/03/07 18:22:29  suhrbier
 * Initiale Version
 *
 * Revision 1.9  2005/03/01 12:43:55  suhrbier
 * Nach Urlaub
 *
 * Revision 1.8  2005/02/11 17:48:08  suhrbier
 * Erste Verbindung BioCASE->PDP
 *
 * Revision 1.7  2005/01/20 14:44:07  suhrbier
 * *** empty log message ***
 *
 * Revision 1.6  2005/01/14 20:58:45  suhrbier
 * *** empty log message ***
 *
 * Revision 1.5  2005/01/14 18:13:41  suhrbier
 * *** empty log message ***
 *
 * Revision 1.4  2005/01/14 17:05:09  suhrbier
 * *** empty log message ***
 *
 * Revision 1.3  2005/01/13 17:50:52  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/01/12 11:13:56  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/01/11 17:40:28  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.biocase.protocol;

import nbi.xml.sax.SAXElement;
import nbi.xmlsec.biocase.protocol.filter.RequestFilter;

import org.apache.log4j.Logger;
import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.AttributesImpl;

/**
 * This class wraps the BioCASE protocol element Request.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.4 $
 * @since
 */
public class Request extends ProtocolType {
    static Logger logger = Logger.getLogger(Request.class);

    Header header = null;

    OperationType opType = null;

    /**
     * Inits this instance.
     * 
     * @param protocolURI
     *            The protocol version of this instance.
     */
    public Request(String protocolURI) {
        super(protocolURI);
    }

    /**
     * Writes the response to a SAX Stream.
     * 
     * @param out
     *            {@link ContentHandler ContentHandler} to write to.
     * @throws SAXException
     */
    public void write(ContentHandler out) throws SAXException{
        AttributesImpl atts = SAXElement.EMPTY_ATTS;
        out.startElement(getProtocolURI(), RequestFilter.LN_ROOT,
                RequestFilter.LN_ROOT, atts);
        if (header != null)
            header.write(out);
        if (opType != null)
            opType.write(out);
        out.endElement(getProtocolURI(), RequestFilter.LN_ROOT,
                RequestFilter.LN_ROOT);
    }

    public String toString() {
        StringBuffer ret = new StringBuffer();
        if (header != null)
            ret.append("header=" + header.toString() + "\n");
        if (opType != null)
            ret.append("opType=" + opType.toString() + "\n");
        return ret.toString();
    }

    /**
     * Gets the header
     * 
     * @return Returns the header.
     */
    public Header getHeader() {
        return header;
    }

    /**
     * Sets header
     * 
     * @param header
     *            The header to set.
     */
    public void setHeader(Header header) {
        this.header = header;
    }

    /**
     * Gets the opType
     * 
     * @return Returns the opType.
     */
    public OperationType getOpType() {
        return opType;
    }

    /**
     * Sets opType
     * 
     * @param opType
     *            The opType to set.
     */
    public void setOpType(OperationType opType) {
        this.opType = opType;
    }
}
