/*
 * $Id: SecurityDiagnostic.java,v 1.1 2006/07/24 08:15:36 suhrbier Exp $
 * Created on 24.07.2006
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: SecurityDiagnostic.java,v $
 * Revision 1.1  2006/07/24 08:15:36  suhrbier
 * + class SecurityDiagnostic
 *
 */
package nbi.xmlsec.biocase.protocol;

/**
 * Diagnostic class with fixed code attribute ""SECURITY"".
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.1 $
 * @since 
 */

public class SecurityDiagnostic extends Diagnostic {
    /** String value of the security code attribute */
    static public String CODE_SECURITY="SECURITY";

    /**
     * Inits this instance.
     * Sets the code attribute to {@link #CODE_SECURITY CODE_SECURITY}.
     *	 
     * @param protocolURI
     *            The protocol version of this instance.
     */
    public SecurityDiagnostic(String protocolURI) {
        super(protocolURI);
        setCode(CODE_SECURITY);
    }

    /**
     * Inits this instance.
     * Sets the code attribute to {@link #CODE_SECURITY CODE_SECURITY}.
     * 
     * @param protocolURI
     *            The protocol version of this instance.
     * @param severity The severityattribute of this diagnostic.
     * @param value The value of this diagnostic.
     */
    public SecurityDiagnostic(String protocolURI, String severity,
            String value) {
        super(protocolURI, CODE_SECURITY, severity, value);
    }
}
