/*
 * $Id: RBACFilter.java,v 1.25 2006/08/14 10:16:12 suhrbier Exp $
 * Created on 06.07.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: RBACFilter.java,v $
 * Revision 1.25  2006/08/14 10:16:12  suhrbier
 * Fehler behoben beim Erstellen von signRequestCtx (Kein hash() fr Attribute-class).
 * Umgestellt auf Konstruktor.
 *
 * Revision 1.24  2006/07/25 14:34:48  suhrbier
 * signed Elements with namespace-URI working.
 *
 * Revision 1.23  2006/07/24 08:21:10  suhrbier
 * + class SecurityDiagnostic
 *
 * Revision 1.22  2006/07/21 18:38:13  suhrbier
 * +XPATH2-References(but not really working)
 * +Signing of requested elements
 * +SECURITY-CODE
 *
 * Revision 1.21  2006/07/14 21:17:57  suhrbier
 * Basis fr Validation gelegt (Trennen von Signature und Document).
 *
 * Revision 1.20  2006/07/12 09:42:41  suhrbier
 * Fehler behoben in PEPHandler bzgl. getRoles/getCertificates wenn kein clientCert-Parameter vorliegt.
 *
 * Revision 1.19  2006/05/08 17:21:57  suhrbier
 * Transform Response into DOM Document.
 *
 * Revision 1.18  2006/04/19 15:31:20  suhrbier
 * *** empty log message ***
 *
 * Revision 1.17  2005/10/07 18:27:45  suhrbier
 * Beginn Umbau XACML-Builder (4all PolicyTreeElements).
 *
 * Revision 1.16  2005/09/02 19:46:00  suhrbier
 * + Denied treeElements are returned as Info-Diagnostics.
 *
 * Revision 1.15  2005/08/17 19:03:28  suhrbier
 * Durchgang wiederhergestellt, Rechteabfrage funktioniert nicht ?
 *
 * Revision 1.14  2005/08/15 13:24:45  suhrbier
 * Zwischenspeicherung
 *
 * Revision 1.13  2005/08/10 20:57:12  suhrbier
 * Updated JavaDoc & Comments
 *
 * Revision 1.12  2005/08/10 12:24:51  suhrbier
 * Updated ProtocolFilter to push element on the stack before calling filterElement
 *
 * Revision 1.11  2005/08/10 11:59:37  suhrbier
 * All Filters tested.
 *
 * Revision 1.10  2005/08/05 14:28:02  suhrbier
 * Updated javadoc and comments.
 *
 * Revision 1.9  2005/08/05 11:35:54  suhrbier
 * Updated javadoc and comments.
 *
 * Revision 1.8  2005/08/04 23:28:49  suhrbier
 * Response komplett auf ProtocolFilter umgestellt.
 *
 * Revision 1.7  2005/08/04 10:10:36  suhrbier
 * Umstellung auf ProtocolFilter
 *
 * Revision 1.6  2005/07/26 13:19:46  suhrbier
 * + evaluateAttributes und Elements
 * speed optimizing
 *
 * Revision 1.5  2005/07/25 18:59:00  suhrbier
 * Updated JavaDoc
 *
 * Revision 1.4  2005/07/25 15:30:07  suhrbier
 * HttpInputStream updated.
 *
 * Revision 1.3  2005/07/23 10:58:19  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/07/22 17:28:06  suhrbier
 * ResponseFilter implementiert, aber ungetestet.
 *
 * Revision 1.1  2005/07/21 19:00:32  suhrbier
 * *** empty log message ***
 *
 * Revision 1.10  2005/07/15 18:09:18  suhrbier
 * JavaDoc added
 *
 * Revision 1.9  2005/07/15 09:16:29  suhrbier
 * JavaDoc added
 *
 * Revision 1.8  2005/07/13 09:37:39  suhrbier
 * javadoc added
 * tests refined
 *
 * Revision 1.7  2005/07/13 09:36:42  suhrbier
 * javadoc added
 * tests refined
 *
 * Revision 1.6  2005/07/11 21:17:42  suhrbier
 * ReponseFilter tests updated
 *
 * Revision 1.5  2005/07/11 20:55:08  suhrbier
 * ReponseFilter tests addeds
 *
 * Revision 1.4  2005/07/11 10:35:07  suhrbier
 * ReponseFilter tests addeds
 *
 * Revision 1.3  2005/07/08 13:17:57  suhrbier
 * RBACFilter mit XMLWriter verknpft
 *
 * Revision 1.2  2005/07/07 18:39:19  suhrbier
 * RBACFilter (logged version) recursive and with attributes
 *
 * Revision 1.1  2005/07/06 12:14:10  suhrbier
 * beginn RBACFilter
 *
 */
package nbi.xmlsec.biocase.protocol.filter;

import java.util.HashSet;
import java.util.Set;
import java.util.Stack;

import nbi.xml.sax.FilterStack;
import nbi.xml.sax.SAXElement;
import nbi.xmlsec.biocase.protocol.Diagnostic;
import nbi.xmlsec.biocase.protocol.SecurityDiagnostic;
import nbi.xmlsec.xacml.profile.rbac.RBACPDP;
import nbi.xmlsec.xacml.profile.rbac.builder.RBACRequestCtxBuilder;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.AttributesImpl;

import com.sun.xacml.ctx.Result;

/**
 * The class RBACFilter removes treeElements and attributes according to
 * policies defined in XACML-RBAC policies from the SAX stream.
 * <p>
 * The filter acts on incoming SAX-events and delivers these (modified) events
 * to its defined ContentHandler. It uses the {@link RBACPDP RBACPDP}, which
 * must be given as {@link RBACFilterParameter RBACFilterParameter}via
 * {@link ProtocolFilter#setFilterParameter(Object) setFilterParameter(Object)}
 * to grant access or not based on a given roleset, action and resource. The
 * latter is build up from the formatURI and the path to the current element.
 * When access is refused for a given element, the complete element will be
 * removed from the stream recursively, including all subelements and character
 * events. When access is refused for an element attribute, only this single
 * attribute will be removed.
 * </p>
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.25 $
 * @since
 */
public class RBACFilter extends ProtocolFilter {
    static Logger logger = Logger.getLogger(RBACFilter.class);

    /** Stack storing the evaluated access conditions for each XML element */
    private Stack deny = null;

    /** Set of element paths evaluated for signing */
    private Set signElements = null;

    /** Track mode for the filter stack */
    final static int trackMode = FilterStack.TRACK_MODE_ATTRIBUTES
            | FilterStack.TRACK_MODE_LOCALNAME | FilterStack.TRACK_MODE_QNAME
            | FilterStack.TRACK_MODE_CHARACTERS;

    /**
     * Inits the filter instance.
     * 
     * @param protocolURI
     *            protocol version URI of this filter.
     * @param filterRoot
     *            Root element for this filter.
     * @param filterMode
     *            filterMode of this filter
     *            {@link ProtocolFilter#filterMode ProtocolFilter.filterMode}.
     */
    public RBACFilter(String protocolURI, String filterRoot, int filterMode) {
        super(protocolURI, filterRoot, trackMode, filterMode);
        deny = new Stack();
        signElements = new HashSet();
        initSubFilter();
    }

    /**
     * Inits the filter instance with specified parent.
     * 
     * @param parent
     *            parent reader.
     * @param protocolURI
     *            protocol version URI of this filter.
     * @param filterRoot
     *            Root element for this filter.
     * @param filterMode
     *            filterMode of this filter
     *            {@link ProtocolFilter#filterMode ProtocolFilter.filterMode}.
     */
    public RBACFilter(XMLReader parent, String protocolURI, String filterRoot, int filterMode) {
        super(parent, protocolURI, filterRoot, trackMode, filterMode);
        deny = new Stack();
        signElements = new HashSet();
        initSubFilter();
    }

    /**
     * Registers subfilters for subelements.
     */
    private void initSubFilter() {
        registerSubFilter(null, null);
    }

    /**
     * Evaluates the attributes of the given element with the pdp. The element's
     * attributes are evaluated based on the concatenated uri of the current
     * element, the elementPath, "@" as delimiter and the attribute's local name
     * as PDP resource argument. Denied attributes are removed from the SAX
     * stream.
     * 
     * @param element
     *            element containing the attributes to evaluate.
     * @return element with possibly removed attributes.
     */
    protected SAXElement evaluateAttributes(SAXElement element) {

        // Remember the element's attributes
        Attributes atts = element.getAttributes();
        // Holds the filtered attribute list to be returned (empty when atts is
        // empty)
        AttributesImpl filterAtts = new AttributesImpl(atts);

        // Evaluate access conditions for the element's attributes and remove
        // them
        // from the list when access is denied.
        if (atts.getLength() > 0) {
            // element contains attributes
            // Concatenate base path for element attributes
            String attributeElementPath = element.getURI().toString()
                    + elementStack.buildElementPath("/") + "@";
            for (int i = 0; i < atts.getLength(); i++) {
                // Construct PDP resource for the current attribute
                String pdpResource = attributeElementPath
                        + atts.getLocalName(i);
                // Evaluate current attribute
                RBACRequestCtxBuilder requestBuilder = new RBACRequestCtxBuilder();
                requestBuilder.addRoles(getParameter().getRoles());
                requestBuilder.addResource(pdpResource);
                requestBuilder.addAction(getParameter().getPdpAction());

                if (getParameter().getPdp().evaluate(
                        requestBuilder.getInstance()).getDecision() == Result.DECISION_PERMIT) {
                } else {
                    // remove attribute when denied
                    filterAtts.removeAttribute(i);
                    getParameter()
                            .getDiagnostics()
                            .addDiagnostic(
                                    new SecurityDiagnostic(
                                            getProtocolURI(),
                                            Diagnostic.SEVERITY_INFO,
                                            getParameter().getPdpAction()
                                                    + " denied on "
                                                    + pdpResource
                                                    + " for role(s) "
                                                    + PDPFilterParameter
                                                            .getRolesAsString(getParameter()
                                                                    .getRoles())));
                }
            }
        }
        // Update element with the new attributes
        element.setAttributes(filterAtts);
        return element;
    }

    /**
     * Evaluates the given element with the PDP. The current element is
     * evaluated. If it is permitted, then the element's attributes are
     * evaluated. Denied attributes are removed from the element. The attribute
     * list may be empty!
     * All permitted elements are added to the {@link #signElements list of signable elements} and may be retrieved using {@link #getSignElements() getSignElements()} when parsing is complete.
     * 
     * @return null, if element was denied, the element with possibly removed
     *         attributes otherwise.
     */
    protected SAXElement evaluateElement(SAXElement element) {
        // Filtered element to be returned
        SAXElement ret = null;

        // Construct PDP resource for the current element
        String pdpResource = element.getURI().toString()
                + elementStack.buildElementPath("/");

        // Evaluate the element's access conditions. If permitted, evaluate and
        // filter the element's attributes too.
        if (deny.empty() || (Boolean) deny.peek() == Boolean.FALSE) {
            // if its the root element or the element ist not recursively denied
            // evaluate element and push its deny state on the stack
            if (getParameter() != null) {
                RBACRequestCtxBuilder requestBuilder = new RBACRequestCtxBuilder();
                requestBuilder.addRoles(getParameter().getRoles());
                requestBuilder.addResource(pdpResource);
                requestBuilder.addAction(getParameter().getPdpAction());

                if (getParameter().getPdp().evaluate(
                        requestBuilder.getInstance()).getDecision() == Result.DECISION_PERMIT) {
                    // element permitted -> evaluate attributes
                    deny.push(Boolean.FALSE);
                    
                    // create request to check if response element to be signed
                    if( getParameter().pdpAction.endsWith("search-response"))
                    {
                        RBACRequestCtxBuilder signRequestBuilder = new RBACRequestCtxBuilder();
                        signRequestBuilder.addRoles(getParameter().getRoles());
                        signRequestBuilder.addResource(pdpResource);
                        signRequestBuilder.addAction("signElements-response");
                        if (getParameter().getPdp().evaluate(
                                signRequestBuilder.getInstance()).getDecision() == Result.DECISION_PERMIT) {
                            signElements.add(pdpResource);
                        }
                    }
                    
                    ret = evaluateAttributes(element);
                } else {
                    // element denied -> do not evaluate attributes
                    deny.push(Boolean.TRUE);
                    getParameter()
                            .getDiagnostics()
                            .addDiagnostic(
                                    new SecurityDiagnostic(
                                            getProtocolURI(),
                                            Diagnostic.SEVERITY_INFO,
                                            getParameter().getPdpAction()
                                                    + " denied on "
                                                    + pdpResource
                                                    + " for role(s) "
                                                    + PDPFilterParameter
                                                            .getRolesAsString(getParameter()
                                                                    .getRoles())));
                }
            }
        } else {
            // element recursively denied, deny this element also
            deny.push(Boolean.TRUE);
            getParameter().getDiagnostics().addDiagnostic(
                    new SecurityDiagnostic(getProtocolURI(),
                            Diagnostic.SEVERITY_INFO, getParameter()
                                    .getPdpAction()
                                    + " denied on "
                                    + pdpResource
                                    + " for role(s) "
                                    + PDPFilterParameter
                                            .getRolesAsString(getParameter()
                                                    .getRoles())));
        }
        return ret;
    }

    /**
     * Evaluates the current element, removes it or some of its attributes
     * before it will be followed up.
     * 
     * @see ProtocolFilter#filterElement(SAXElement)
     */
    protected SAXElement filterElement(SAXElement element) throws SAXException {
        return evaluateElement(element);
    }

    /**
     * Cleans up the deny stack, when the endElement event for the element was
     * received. Prevents further processing of the endElement event when
     * element was denied before.
     * 
     * @see ProtocolFilter#parseElement(SAXElement)
     */
    protected SAXElement parseElement(SAXElement element) throws SAXException {
        SAXElement ret = null;
        if (deny.empty() || ((Boolean) deny.peek()) == Boolean.FALSE)
            ret = element;
        deny.pop();
        return ret;
    }

    /**
     * Prevents further processing of the character event, if the element was
     * denied before.
     * 
     * @see ProtocolFilter#filterCharacters(SAXElement)
     */
    protected SAXElement filterCharacters(SAXElement element)
            throws SAXException {
        SAXElement ret = null;
        if (deny.empty() || ((Boolean) deny.peek()) == Boolean.FALSE)
            ret = element;
        return ret;
    }

    /**
     * Gets the parameter of this filter.
     * 
     * @return filter parameter.
     */
    protected RBACFilterParameter getParameter() {
        return (RBACFilterParameter) getFilterParameter();
    }
    /**
     * Gets the set of element paths evaluated for signing.
     * @return The set of element paths evaluated for signing.
     */
    public Set getSignElements() {
        return signElements;
    }
}
