/*
 * $Id: ResponseFilterParameter.java,v 1.4 2005/08/17 19:03:28 suhrbier Exp $
 * Created on 04.08.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: ResponseFilterParameter.java,v $
 * Revision 1.4  2005/08/17 19:03:28  suhrbier
 * Durchgang wiederhergestellt, Rechteabfrage funktioniert nicht ?
 *
 * Revision 1.3  2005/08/10 20:57:12  suhrbier
 * Updated JavaDoc & Comments
 *
 * Revision 1.2  2005/08/06 16:16:14  suhrbier
 * Zwischenspeicherung
 *
 * Revision 1.1  2005/08/04 23:28:49  suhrbier
 * Response komplett auf ProtocolFilter umgestellt.
 *
 */
package nbi.xmlsec.biocase.protocol.filter;

import java.util.Set;

import nbi.xmlsec.biocase.protocol.Request;
import nbi.xmlsec.xacml.profile.rbac.RBACPDP;

/**
 * Container class to store Parameters for the {@link ResponseFilter ResponseFilter}.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.4 $
 * @since 
 */

public class ResponseFilterParameter extends PDPFilterParameter {
    /** The request initiating this response */
    private Request request;

    /**
     * Inits the ResponseFilterParameter. Arguments must not be null.
     * @param request request initiating this response.
     * @param pdp The pdp with evaluation access rights from XACML-policies.
     * @param roles Set of roles to be evaluated from the pdp.
     */
    public ResponseFilterParameter(Request request, RBACPDP pdp, Set roles) {
        super(pdp,roles);
        this.request = request;
        this.checkInit();
    }

    /**
     * Checks the correct initialisation of the class initialisation parameters.
     */
    private void checkInit() {
        if (this.request == null )
            throw new IllegalArgumentException("Arguments must not be null");
    }
    /**
     * Gets the request
     * @return Returns the request.
     */
    public Request getRequest() {
        return request;
    }
}
