/*
 * $Id: ConfigurationUtil.java,v 1.1 2005/10/26 15:20:33 suhrbier Exp $
 * Created on 14.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: ConfigurationUtil.java,v $
 * Revision 1.1  2005/10/26 15:20:33  suhrbier
 * *** empty log message ***
 *
 * Revision 1.4  2005/10/24 20:48:59  suhrbier
 * RoleAssignmentPolicyTest luft bis auf encode(). (target=null)
 *
 * Revision 1.3  2005/10/24 09:38:39  suhrbier
 * Assignment test ok
 *
 * Revision 1.2  2005/10/15 18:00:51  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/10/14 18:31:00  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.configuration.util;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.configuration.Configuration;

/**
 * Class to support acting on {@link Configuration Configuration} instances.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.1 $
 * @since
 */

public class ConfigurationUtil {

    static public List getSubsets(Configuration config, String prefix) {
        ArrayList result = new ArrayList();
        int i=0;
        String key = prefix + "(0)";
        Configuration sub = config.subset(key);
        while(!sub.isEmpty())
        {
            result.add(sub);
            key = prefix + "(" + ++i + ")";
            sub= config.subset( key );
        }
        return result;
    }
}
