/*
 * $Id: ActionMatchBuilder.java,v 1.5 2005/12/19 19:11:06 suhrbier Exp $
 * Created on 02.02.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: ActionMatchBuilder.java,v $
 * Revision 1.5  2005/12/19 19:11:06  suhrbier
 * Version ready to be delivered to BGBM.
 *
 * Revision 1.4  2005/10/15 21:37:40  suhrbier
 * *** empty log message ***
 *
 * Revision 1.3  2005/10/14 18:31:00  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/10/12 10:36:27  suhrbier
 * Target und TargetMatchBuilder completed.
 *
 * Revision 1.1  2005/10/07 17:05:51  suhrbier
 * Beginn Umbau XACML-Builder.
 *
 * Revision 1.1  2005/03/07 18:22:33  suhrbier
 * Initiale Version
 *
 * Revision 1.2  2005/02/03 17:30:09  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/02/02 17:33:54  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/02/02 17:20:09  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.builder;

import java.net.URI;

import com.sun.xacml.TargetMatch;
import com.sun.xacml.attr.AttributeValue;

/**
 * Class to create ActionMatch instances.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.5 $
 * @since
 */

public class ActionMatchBuilder extends TargetMatchBuilder {

    /**
     * Sets the function used to do the matching.
     * 
     * @param matchFunction
     *            FunctionId.
     */
    public ActionMatchBuilder(String matchFunction) {
        super(TargetMatch.ACTION);
        try {
            setMatchFunction(matchFunction);
        } catch (Exception e) {
            throw new IllegalArgumentException("Unknown match function"
                    + matchFunction);
        }
    }

    /**
     * Sets the function used to do the matching.
     * 
     * @param matchFunction
     *            FunctionId.
     */
    public ActionMatchBuilder(URI matchFunction) {
        super(TargetMatch.ACTION);
        try {
            setMatchFunction(matchFunction);
        } catch (Exception e) {
            throw new IllegalArgumentException("Unknown match function"
                    + matchFunction);
        }
    }
    /* (non-Javadoc)
     * @see nbi.xmlsec.xacml.builder.TargetMatchBuilder#createMatchValue()
     */
    public AttributeValue createMatchValue() {
        return null;
    }
}
