/*
 * $Id: AttributeBaseBuilder.java,v 1.1 2005/10/10 18:51:43 suhrbier Exp $
 * Created on 10.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: AttributeBaseBuilder.java,v $
 * Revision 1.1  2005/10/10 18:51:43  suhrbier
 * AttributeSelector finished.
 *
 */
package nbi.xmlsec.xacml.builder;

import java.net.URI;

/**
 * Base class for the classes AttributeDesignatorBuilder and AttributeSelectorBuilder.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.1 $
 * @since 
 */

public class AttributeBaseBuilder {

    /** The data type resolved by this designator */
    protected URI type = null;
    /** Whether resolution must find a value */
    protected boolean mustBePresent = false;

    /**
     * Sets the data type resolved by this designator.
     * 
     * @param type
     *            The data type resolved to set.
     */
    public void setType(URI type) {
        this.type = type;
    }

    /**
     * Sets the data type resolved by this designator.
     * 
     * @param type
     *            The data type resolved to set.
     */
    public void setType(String type) {
        this.type = URI.create(type);
    }

    /**
     * Set whether resolution must find a value.
     * 
     * @param mustBePresent
     *            true, if must find a value, false otherwise.
     */
    public void setMustBePresent(boolean mustBePresent) {
        this.mustBePresent = mustBePresent;
    }

}
