/*
 * $Id: AttributeSelectorBuilder.java,v 1.2 2005/10/10 18:51:43 suhrbier Exp $
 * Created on 10.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: AttributeSelectorBuilder.java,v $
 * Revision 1.2  2005/10/10 18:51:43  suhrbier
 * AttributeSelector finished.
 *
 * Revision 1.1  2005/10/10 18:27:17  suhrbier
 * AttributeDesignator finished.
 *
 */
package nbi.xmlsec.xacml.builder;

import com.sun.xacml.attr.AttributeSelector;
import com.sun.xacml.cond.Evaluatable;

/**
 * Class to create {@link AttributeSelector AttributeSelector}instances.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since
 */

public class AttributeSelectorBuilder extends AttributeBaseBuilder {
    /** the XPath to query */
    String contextPath = null;

    /**
     * the XPath version to use, which must be a valid XPath version string (the
     * identifier for XPath 1.0 is provided in AbstractPolicy)
     */
    String xpathVersion = null;

    /**
     * Creates a new AttributeSelector instance.
     * 
     * @see EvaluatableBuilder#getInstance()
     */
    public Evaluatable getInstance() {
        return new AttributeSelector(type, contextPath, mustBePresent,
                xpathVersion);
    }

    /**
     * Sets the XPath to query.
     * 
     * @param contextPath
     *            The contextPath to querys.
     */
    public void setContextPath(String contextPath) {
        this.contextPath = contextPath;
    }

    /**
     * Sets the XPath version to use, which must be a valid XPath version string
     * (the identifier for XPath 1.0 is provided in AbstractPolicy).
     * 
     * @param xpathVersion
     *            The xpathVersion to use.
     */
    public void setXpathVersion(String xpathVersion) {
        this.xpathVersion = xpathVersion;
    }
}
