/*
 * $Id: ConditionTypeBuilder.java,v 1.3 2006/04/27 18:22:06 suhrbier Exp $
 * Created on 10.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: ConditionTypeBuilder.java,v $
 * Revision 1.3  2006/04/27 18:22:06  suhrbier
 * Condition im RoleManager eingebaut.
 *
 * Revision 1.2  2006/04/24 19:50:20  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/10/10 11:20:28  suhrbier
 * +Apply(Type)Builder
 * +CollectionUtils + Tests
 *
 */
package nbi.xmlsec.xacml.builder;

import nbi.xmlsec.xacml.util.SyntaxScheme;

import com.sun.xacml.ParsingException;
import com.sun.xacml.UnknownIdentifierException;
import com.sun.xacml.cond.FunctionTypeException;

/**
 * Class to create ConditionTypeBuilder instances.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.3 $
 * @since
 */

public class ConditionTypeBuilder extends ApplyBuilder {
    public ConditionTypeBuilder() {
        super();
        isCondition = true;
    }

    /**
     * @param scheme
     * @throws ParsingException
     * @throws UnknownIdentifierException
     * @throws FunctionTypeException
     */
    public ConditionTypeBuilder(SyntaxScheme scheme) throws ParsingException,
            UnknownIdentifierException, FunctionTypeException {
        super(scheme);
        isCondition = true;
    }
}
