/*
 * $Id: EnvironmentAttributeDesignatorBuilder.java,v 1.3 2006/04/24 19:50:20 suhrbier Exp $
 * Created on 02.02.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: EnvironmentAttributeDesignatorBuilder.java,v $
 * Revision 1.3  2006/04/24 19:50:20  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/10/10 18:27:17  suhrbier
 * AttributeDesignator finished.
 *
 * Revision 1.1  2005/10/07 17:05:51  suhrbier
 * Beginn Umbau XACML-Builder.
 *
 * Revision 1.1  2005/03/07 18:22:33  suhrbier
 * Initiale Version
 *
 * Revision 1.2  2005/02/03 17:30:09  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/02/02 17:20:09  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.builder;

import com.sun.xacml.attr.AttributeDesignator;

/**
 * Class to create EnvironmentAttributeDesignator instances.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.3 $
 * @since
 */

public class EnvironmentAttributeDesignatorBuilder extends
        AttributeDesignatorBuilder {
    /** Identifier of the environment attribute (undefined) */
    public static final String attributeId = null;
    
    public static final String ENVIRONMENT_CURRENT_TIME = "urn:oasis:names:tc:xacml:1.0:environment:current-time";

    public static final String ENVIRONMENT_CURRENT_DATE = "urn:oasis:names:tc:xacml:1.0:environment:current-date";

    public static final String ENVIRONMENT_CURRENT_DATETIME = "urn:oasis:names:tc:xacml:1.0:environment:current-dateTime";

    public EnvironmentAttributeDesignatorBuilder() {
        super(AttributeDesignator.ENVIRONMENT_TARGET,null);
    }
    public EnvironmentAttributeDesignatorBuilder(String attributeId) {
            super(AttributeDesignator.ENVIRONMENT_TARGET,attributeId);
    }
}
