/*
 * $Id: PolicySetReferenceBuilder.java,v 1.1 2005/10/14 18:31:00 suhrbier Exp $
 * Created on 14.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: PolicySetReferenceBuilder.java,v $
 * Revision 1.1  2005/10/14 18:31:00  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.builder;

import java.net.URI;

import com.sun.xacml.PolicyReference;
import com.sun.xacml.PolicyTreeElement;
import com.sun.xacml.finder.PolicyFinder;

/**
 * Class to create policy set reference instances.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.1 $
 * @since
 */

public class PolicySetReferenceBuilder extends AbstractPolicyBuilder {

    /** The PolicyFinder used to handle the reference */
    PolicyFinder finder = null;

    /**
     * Creates a policy set reference builder.
     * 
     * @param identifier
     *            rule identifier.
     */
    public PolicySetReferenceBuilder(URI identifier) {
        super();
        setIdentifier(identifier);
    }

    /**
     * Creates a new policy set reference instance.
     * 
     * @see PolicyTreeElementBuilder#getInstance()
     */
    public PolicyTreeElement getInstance() {
        return new PolicyReference(identifier,
                PolicyReference.POLICYSET_REFERENCE, finder);
    }

    /**
     * Sets the policy finder used to handle the reference.
     * 
     * @param finder
     *            The policy finder to set.
     */
    public void setFinder(PolicyFinder finder) {
        this.finder = finder;
    }
}
