/*
 * $Id: ResourceAttributeDesignatorBuilder.java,v 1.4 2006/05/03 19:18:33 suhrbier Exp $
 * Created on 02.02.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: ResourceAttributeDesignatorBuilder.java,v $
 * Revision 1.4  2006/05/03 19:18:33  suhrbier
 * weitere environment-Attribute hinzugefgt.
 *
 * Revision 1.3  2005/10/14 18:30:59  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/10/10 18:27:17  suhrbier
 * AttributeDesignator finished.
 *
 * Revision 1.1  2005/10/07 17:05:51  suhrbier
 * Beginn Umbau XACML-Builder.
 *
 * Revision 1.2  2005/04/04 21:23:22  suhrbier
 * Erste lauffhige Version mit RoleEnableAuth und RBACPDP
 *
 * Revision 1.1  2005/03/07 18:22:33  suhrbier
 * Initiale Version
 *
 * Revision 1.2  2005/02/03 17:30:09  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/02/02 17:20:09  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.builder;

import com.sun.xacml.attr.AttributeDesignator;

/**
 * Class to create ResourceAttributeDesignator instances.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.4 $
 * @since
 */

public class ResourceAttributeDesignatorBuilder extends
        AttributeDesignatorBuilder {
    /** Identifier of the resource attribute */
    public static final String attributeId = "urn:oasis:names:tc:xacml:1.0:resource:resource-id";

    public static final String RESOURCE_CONTENT = "urn:oasis:names:tc:xacml:1.0:resource:resource-content";

    public static final String RESOURCE_SIMPLE_FILE_NAME = "urn:oasis:names:tc:xacml:1.0:resource:simple-file-name";

    public static final String RESOURCE_XPATH = "urn:oasis:names:tc:xacml:1.0:resource:xpath";

    public static final String RESOURCE_UFS_PATH = "urn:oasis:names:tc:xacml:1.0:resource:ufs-path";

    public static final String RESOURCE_SCOPE = "urn:oasis:names:tc:xacml:1.0:resource:scope";

    public static final String RESOURCE_SCOPE_IMMEDIATE = "Immediate";

    public static final String RESOURCE_SCOPE_CHILDREN = "Children";

    public static final String RESOURCE_SCOPE_DESCENDANTS = "Descendants";

    public ResourceAttributeDesignatorBuilder() {
        super(AttributeDesignator.RESOURCE_TARGET, attributeId);
    }

    public ResourceAttributeDesignatorBuilder(String attributeId) {
        super(AttributeDesignator.RESOURCE_TARGET, attributeId);
    }

}
