/*
 * $Id: StringMatchParser.java,v 1.1 2005/11/01 18:45:19 suhrbier Exp $
 * Created on 18.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: StringMatchParser.java,v $
 * Revision 1.1  2005/11/01 18:45:19  suhrbier
 * Permission upgedated.
 *
 * Revision 1.1  2005/10/18 18:15:54  suhrbier
 * RoleAssignment Umstellung abgeschlossen!
 *
 */
package nbi.xmlsec.xacml.parser;

import java.net.URI;

import com.sun.xacml.ParsingException;
import com.sun.xacml.TargetMatch;
import com.sun.xacml.attr.StringAttribute;

/**
 * Parses an StringAttribute match value from a target match
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.1 $
 * @since
 */

public class StringMatchParser extends TargetMatchParser {

    /**
     * 
     */
    public StringMatchParser() {
        super();
    }
    /**
     * Inits the match parser.
     * 
     * @param targetMatch
     *            The target match to parse.
     */
    public StringMatchParser(TargetMatch targetMatch) {
        super(targetMatch);
    }

    /**
     * Get the URI value from the target match {@link StringAttribute StringAttribute}.
     * @return The {@link String String} or <code>null</code>.
     * 
     * @see TargetMatchParser#parseMatchValue()
     */
    public Object parseMatchValue() throws ParsingException {
        String result = null;
        if (super.getMatchValue().getType().equals(
                URI.create(StringAttribute.identifier))) {
            result = ((StringAttribute) super.getMatchValue()).getValue();
        }
        return result;
    }
}
