/*
 * $Id: TargetMatchParser.java,v 1.2 2005/10/21 17:43:02 suhrbier Exp $
 * Created on 18.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: TargetMatchParser.java,v $
 * Revision 1.2  2005/10/21 17:43:02  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/10/18 18:15:54  suhrbier
 * RoleAssignment Umstellung abgeschlossen!
 *
 */
package nbi.xmlsec.xacml.parser;

import com.sun.xacml.ParsingException;
import com.sun.xacml.TargetMatch;
import com.sun.xacml.attr.AttributeValue;
import com.sun.xacml.cond.Evaluatable;
import com.sun.xacml.cond.Function;

/**
 * Abstract Base class to transform {@link TargetMatch TargetMatch}instances
 * into related objects.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since
 */
abstract public class TargetMatchParser {
    TargetMatch targetMatch = null;

    public TargetMatchParser() {
        super();
    }

    /**
     * @param targetMatch
     */
    public TargetMatchParser(TargetMatch targetMatch) {
        super();
        setTargetMatch(targetMatch);
    }

    public abstract Object parseMatchValue() throws ParsingException;

    /**
     * Add comment for getMatchEvaluatable
     * 
     * @return The Evaluatable or <code>null</code>.
     */
    public Evaluatable getMatchEvaluatable() {
        return targetMatch.getMatchEvaluatable();
    }

    /**
     * Add comment for getMatchFunction
     * 
     * @return The Function or <code>null</code>.
     */
    public Function getMatchFunction() {
        return targetMatch.getMatchFunction();
    }

    /**
     * Add comment for getMatchValue
     * 
     * @return The Value or <code>null</code>.
     */
    public AttributeValue getMatchValue() {
        return targetMatch.getMatchValue();
    }

    /**
     * Add comment for getType
     * 
     * @return The Type or <code>null</code>.
     */
    public int getType() {
        return targetMatch.getType();
    }

    /**
     * Add comment for setTargetMatch
     * 
     * @param targetMatch
     */
    public void setTargetMatch(TargetMatch targetMatch) {
        this.targetMatch = targetMatch;
    }
}
