/*
 * $Id: PermissionPolicyIdentifier.java,v 1.2 2005/11/03 21:15:03 suhrbier Exp $
 * Created on 24.03.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: PermissionPolicyIdentifier.java,v $
 * Revision 1.2  2005/11/03 21:15:03  suhrbier
 * Add/Remove PermissionPolicy To Role
 *
 * Revision 1.1  2005/11/02 20:10:33  suhrbier
 * RolePolicySet ready. Start with RoleManager for Permissions.
 *
 * Revision 1.3  2005/10/12 19:49:00  suhrbier
 * Identifier classes revised and JavaDoc.
 *
 * Revision 1.2  2005/08/05 14:58:24  suhrbier
 * Updated javadoc and comments.
 *
 * Revision 1.1  2005/03/24 20:01:18  suhrbier
 * Erzeugen von RBAC-Policies nach V2.0, Schreiben in Verzeichnisstruktur.
 * Es fehlt noch:
 * - checken des Einlesens
 * - PolicyFindetModule um die IdReferences einzulesen
 *
 */
package nbi.xmlsec.xacml.profile.rbac;

/**
 * Implementation of a permission policy identifier.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since
 */

public class PermissionPolicyIdentifier extends Identifier {
    /** Type of this identifier */
    public static String TYPEID = "PermissionPolicy";

    /**
     * Creates a PermissionPolicyIdentifier instance.
     * 
     * @param domain
     *            Domain of the identifier.
     * @param label
     *            Label of the identifier.
     */
    public PermissionPolicyIdentifier(String domain, String label) {
        super(domain, TYPEID, label, true);
    }
}
