/*
 * $Id: RBACPDP.java,v 1.23 2005/12/21 17:39:32 suhrbier Exp $
 * Created on 01.02.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: RBACPDP.java,v $
 * Revision 1.23  2005/12/21 17:39:32  suhrbier
 * Final Version sent to BGBM on 21 December 2005
 *
 * Revision 1.22  2005/12/19 19:11:05  suhrbier
 * Version ready to be delivered to BGBM.
 *
 * Revision 1.21  2005/12/14 17:27:09  suhrbier
 * Neue Policies scheinen jetzt zu laufen...
 *
 * Revision 1.20  2005/12/14 15:34:31  suhrbier
 * Neue Policies scheinen jetzt zu laufen...
 *
 * Revision 1.19  2005/12/09 11:01:29  suhrbier
 * 2 special PolicyFinder fr REA und PDP
 *
 * Revision 1.18  2005/12/07 19:34:54  suhrbier
 * Mehrere Configuration Fehler beim Start von PEP behoben !
 *
 * Revision 1.17  2005/11/04 17:52:36  suhrbier
 * Permission add mit Targets funzt.
 *
 * Revision 1.16  2005/11/02 20:10:32  suhrbier
 * RolePolicySet ready. Start with RoleManager for Permissions.
 *
 * Revision 1.15  2005/10/05 14:38:00  suhrbier
 * Klasse ReflectionUtil eingefhrt.
 *
 * Revision 1.14  2005/10/04 18:21:30  suhrbier
 * Umgestellt auf commons-Configuration
 *
 * Revision 1.13  2005/09/23 19:11:12  suhrbier
 * Jetty Anbindung bis auf Parameter fertig.
 *
 * Revision 1.12  2005/08/31 06:53:10  suhrbier
 * Erste komplett Lauffhige Version mit Provider 2.2.2
 *
 * Revision 1.11  2005/08/20 20:36:49  suhrbier
 * LOP Request Evaluation implementiert.
 *
 * Revision 1.10  2005/08/20 18:52:05  suhrbier
 * Umstellung auf Target Filterung in PermissionPolicySet
 *
 * Revision 1.9  2005/08/06 22:08:29  suhrbier
 * Zwischenspeicherung
 *
 * Revision 1.8  2005/08/05 14:58:24  suhrbier
 * Updated javadoc and comments.
 *
 * Revision 1.7  2005/07/27 13:17:53  suhrbier
 * HashMap zum Cachen von Results in RBACPDP eingefhrt.
 * Kleine Korrekturen zu close in HttpXXX
 *
 * Revision 1.6  2005/07/26 17:39:40  suhrbier
 * Neue Methoden for speed ?
 *
 * Revision 1.5  2005/07/21 19:00:33  suhrbier
 * *** empty log message ***
 *
 * Revision 1.4  2005/07/07 18:39:19  suhrbier
 * RBACFilter (logged version) recursive and with attributes
 *
 * Revision 1.3  2005/04/05 16:31:34  suhrbier
 * Setup fr Prsentation beim BGBM
 *
 * Revision 1.2  2005/04/04 21:23:23  suhrbier
 * Erste lauffhige Version mit RoleEnableAuth und RBACPDP
 *
 * Revision 1.1  2005/04/04 09:38:58  suhrbier
 * + RoleEnableAuth und RBACPDP integriert
 *
 * Revision 1.3  2005/03/29 15:36:52  suhrbier
 * IdRefPolicyModule implementiert.
 * Fehler in RolePolicySet.getPolicySet behoben
 *
 * Revision 1.2  2005/03/22 19:19:59  suhrbier
 * PEP mit SSL-Login und einfache Rollenzuordnung ber Rollenmanager
 *
 * Revision 1.1  2005/03/07 18:22:32  suhrbier
 * Initiale Version
 *
 * Revision 1.1  2005/02/11 17:48:08  suhrbier
 * Erste Verbindung BioCASE->PDP
 *
 * Revision 1.1  2005/02/02 17:20:10  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.profile.rbac;

import java.lang.reflect.InvocationTargetException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import nbi.util.ReflectionUtil;
import nbi.xmlsec.xacml.builder.ActionAttributeDesignatorBuilder;
import nbi.xmlsec.xacml.builder.ResourceAttributeDesignatorBuilder;

import org.apache.commons.configuration.Configuration;
import org.apache.log4j.Logger;

import com.sun.xacml.ConfigurationStore;
import com.sun.xacml.PDP;
import com.sun.xacml.PDPConfig;
import com.sun.xacml.attr.AnyURIAttribute;
import com.sun.xacml.attr.StringAttribute;
import com.sun.xacml.ctx.Attribute;
import com.sun.xacml.ctx.RequestCtx;
import com.sun.xacml.ctx.Result;
import com.sun.xacml.ctx.Subject;
import com.sun.xacml.finder.AttributeFinder;
import com.sun.xacml.finder.impl.CurrentEnvModule;
import com.sun.xacml.finder.impl.SelectorModule;

/**
 * This class implements an PDP acting on XACML policies defined according to
 * the RBAC XACML Profile v.2.0. All needed parameter are read from the
 * {@link org.apache.commons.configuration.Configuration configuration}. The
 * configuration is done within the XML-tag <code>PDP</code>. It mainly
 * consist configuring the underlying {@link PolicyManager PolicyManager}. The
 * evaluation is realised using the method
 * {@link #evaluate(Set, String, String) evaluate(Set,String,String)}.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.23 $
 * @since
 */

public class RBACPDP {
    static Logger logger = Logger.getLogger(RBACPDP.class);

    /**
     * Configuration of this class
     */
    Configuration config;

    /**
     * PolicyManager of this RBACPDP
     */
    PolicyManager polMgr;

    /**
     * The PDP instance.
     */
    PDP pdp;

    /**
     * A Hashmap to store results and fasten the evaluation process when request are equaling.
     */
    HashMap results = new HashMap();

    /**
     * Default constructor. This creates a <code>RBACPDP</code> with a
     * <code>PDP</code> based on the configuration defined by the runtime
     * property com.sun.xcaml.PDPConfigFile.
     */
    public RBACPDP() throws Exception {
        // load the configuration
        ConfigurationStore store = new ConfigurationStore();

        // use the default factories from the configuration
        store.useDefaultFactories();

        // get the PDP configuration's and setup the PDP
        pdp = new PDP(store.getDefaultPDPConfig());
    }

    /**
     * This creates an instance based on the given configuration
     * 
     * @throws IllegalAccessException
     * @throws InstantiationException
     * @throws InvocationTargetException
     * @throws NoSuchMethodException
     * @throws ClassNotFoundException
     *  
     */
    public RBACPDP(Configuration config) throws ClassNotFoundException,
            NoSuchMethodException, InvocationTargetException,
            InstantiationException, IllegalAccessException {
        this.config = config;
        reset();
    }

    /**
     * Resets the RBACPDP reinitialising the PolicyManager instance, reloading the assigned policies needed to create a new PDP instance.
     * @throws IllegalArgumentException
     * @throws SecurityException
     * @throws ClassNotFoundException
     * @throws InstantiationException
     * @throws IllegalAccessException
     * @throws InvocationTargetException
     * @throws NoSuchMethodException
     */
    protected void reset() throws IllegalArgumentException, SecurityException,
            ClassNotFoundException, InstantiationException,
            IllegalAccessException, InvocationTargetException,
            NoSuchMethodException {
        polMgr = (PolicyManager)

        ReflectionUtil.getInstance(config.getString("PolicyManager[@class]"),
                Configuration.class, config.subset("PolicyManager"));

        CurrentEnvModule envAttributeModule = new CurrentEnvModule();
        SelectorModule selectorAttributeModule = new SelectorModule();
        List attributeModules = new ArrayList();
        attributeModules.add(envAttributeModule);
        attributeModules.add(selectorAttributeModule);
        AttributeFinder attributeFinder = new AttributeFinder();
        attributeFinder.setModules(attributeModules);

        pdp = new PDP(new PDPConfig(attributeFinder, polMgr.getPolicyFinder(),
                null));

    }

    /**
     * Evaluates a request
     * @param request The request context to evaluated
     * @return The evaluation result.
     */
    public Result evaluate(RequestCtx request) {
        Result result = (Result) pdp.evaluate(request).getResults().toArray()[0];
        //        result.encode(System.out);
        return result;
    }

    /**
     * Evaluates the request based on a set of roles, a resource and an action defined according the XACML RBAC profile v2.0.
     * The method evaluates all roles sequentially, and returns <code>true</code> if any of the evaluation results equals to permit.
     * 
     * @param roleIds Set of {@link RoleAssignmentPolicyIdentifier RoleAssignmentPolicyIdentifiers}.
     * @param resource The resource as String.
     * @param action The action as String.
     * @return <code>true</code>, if at least one the evaluation result equals to permit, <code>false</code> otherwise.
     */
    public boolean evaluate(Set roleIds, String resource, String action) {
        boolean ret = false;
        RequestCtx request = null;
        Iterator roleIt = roleIds.iterator();
        try {
            while (roleIt.hasNext()) {
                RoleAssignmentPolicyIdentifier roleId = (RoleAssignmentPolicyIdentifier) roleIt
                        .next();
                String reqKey = Integer.toString(roleIds.hashCode())
                        + Integer.toString(resource.hashCode())
                        + Integer.toString(action.hashCode());
                Result result = (Result) results.get(reqKey);
                if (result == null) {
                    if (request == null)
                        request = createRequest(roleId, resource, action);
                    else
                        request = modifyRequest(request, roleId, null, null);
                    result = evaluate(request);
                    results.put(reqKey, result);
                }
                //                result.encode(System.out);
                if (result.getDecision() == Result.DECISION_PERMIT) {
                    ret = true;
                    //                    logger.info("PERMIT " + action + " on " + resource + "
                    // for role " + roleId );
                    break;
                } else
                    logger.info("DENY " + action + " on " + resource
                            + " for role " + roleId);
            }
        } catch (URISyntaxException e) {
            logger.error("evaluate(Set,String,String: " + e.getMessage());
        }
        return ret;
    }

    /**
     * Modifies a given request context based on the given parameeters.
     * @param request The request to modify
     * @param roleId if not null, then the suject changes to the new roleId.
     * @param resource if not null, then the resource changes to the new resource.
     * @param action if not null, then the action changes to the new action.
     * @return The modified request context.
     * @throws URISyntaxException
     */
    public RequestCtx modifyRequest(RequestCtx request,
            RoleAssignmentPolicyIdentifier roleId, String resource,
            String action) throws URISyntaxException {
        if (request != null) {
            Set subjects = request.getSubjects();
            Set resources = request.getResource();
            Set actions = request.getAction();
            Set environments = request.getEnvironmentAttributes();
            if (roleId != null)
                subjects = createSubject(roleId);
            if (resource != null)
                resources = createResource(resource);
            if (action != null)
                actions = createAction(action);
            request = new RequestCtx(subjects, resources, actions, environments);
        }
        return request;
    }

    /**
     * Creates the subject part of a request context on a given RoleAssignmentPolicyIdentifier.
     * @param roleId The RoleAssignmentPolicyIdentifier 
     * @return The subject with the new identifier(may be empty on error).
     * @throws URISyntaxException
     */
    public Set createSubject(RoleAssignmentPolicyIdentifier roleId)
            throws URISyntaxException {
        HashSet subjects = new HashSet();
        HashSet subjectAttrs = new HashSet();
        URI subjectId = new URI(RolePolicySet.ATTRIBUTE_ID);
        AnyURIAttribute subjectValue = new AnyURIAttribute(
                new RoleValueIdentifier(roleId.getDomain(), roleId.getLabel())
                        .toURI());
        subjectAttrs.add(new Attribute(subjectId, null, null, subjectValue));
        subjects.add(new Subject(subjectAttrs));
        return subjects;
    }

    /**
     * Creates the resource part of a request context on a given reource String.
     * @param resource The resource string. 
     * @return The resource with the new resource string(may be empty on error).
     * @throws URISyntaxException
     */
    public Set createResource(String resource) throws URISyntaxException {
        HashSet resources = new HashSet();
        URI resourceId = new URI(ResourceAttributeDesignatorBuilder.attributeId);
        StringAttribute resourceValue = new StringAttribute(resource);
        resources.add(new Attribute(resourceId, null, null, resourceValue));
        return resources;
    }

    /**
     * Creates the action part of a request context on a given reource String.
     * @param action The action string. 
     * @return The action with the new action string(may be empty on error).
     * @throws URISyntaxException
     */
    public Set createAction(String action) throws URISyntaxException {
        HashSet actions = new HashSet();
        URI actionId = new URI(ActionAttributeDesignatorBuilder.attributeId);
        StringAttribute actionValue = new StringAttribute(action);
        actions.add(new Attribute(actionId, null, null, actionValue));
        return actions;
    }

    /**
     * Create a request from a RoleAssignmentPolicyIdentifier, a resource string and an action string.
     * @param roleId RoleAssignmentPolicyIdentifier.
     * @param resource resource string.
     * @param action action string.
     * @return The request context.
     * @throws URISyntaxException
     */
    public RequestCtx createRequest(RoleAssignmentPolicyIdentifier roleId,
            String resource, String action) throws URISyntaxException {
        HashSet environments = new HashSet();
        return new RequestCtx(createSubject(roleId), createResource(resource),
                createAction(action), environments);
    }
}
