/*
 * $Id: RoleManager.java,v 1.34 2006/04/27 18:22:22 suhrbier Exp $
 * Created on 08.02.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: RoleManager.java,v $
 * Revision 1.34  2006/04/27 18:22:22  suhrbier
 * Condition im RoleManager eingebaut.
 *
 * Revision 1.33  2006/04/20 17:15:28  suhrbier
 * *** empty log message ***
 *
 * Revision 1.32  2005/12/19 19:11:04  suhrbier
 * Version ready to be delivered to BGBM.
 *
 * Revision 1.31  2005/12/14 15:34:30  suhrbier
 * Neue Policies scheinen jetzt zu laufen...
 *
 * Revision 1.30  2005/12/09 11:01:28  suhrbier
 * 2 special PolicyFinder fr REA und PDP
 *
 * Revision 1.29  2005/12/06 17:12:15  suhrbier
 * list Befehl implementiert und getestet.
 * Fehler bei Domains der auf den DirectoryFileFitler von commons.io zurckgeht.
 *
 * Revision 1.28  2005/12/05 19:04:04  suhrbier
 * RoleManager tested, but list command.
 *
 * Revision 1.27  2005/12/05 11:26:07  suhrbier
 * *** empty log message ***
 *
 * Revision 1.26  2005/12/04 15:30:36  suhrbier
 * *** empty log message ***
 *
 * Revision 1.25  2005/11/07 21:02:36  suhrbier
 * removeUserToRole test completed.
 *
 * Revision 1.24  2005/11/07 20:21:36  suhrbier
 * *** empty log message ***
 *
 * Revision 1.23  2005/11/07 10:59:40  suhrbier
 * *** empty log message ***
 *
 * Revision 1.22  2005/11/04 17:52:36  suhrbier
 * Permission add mit Targets funzt.
 *
 * Revision 1.21  2005/11/03 21:15:03  suhrbier
 * Add/Remove PermissionPolicy To Role
 *
 * Revision 1.20  2005/11/02 20:10:32  suhrbier
 * RolePolicySet ready. Start with RoleManager for Permissions.
 *
 * Revision 1.19  2005/11/01 11:50:45  suhrbier
 * RoleManager add, remove and list of users completed.
 *
 * Revision 1.18  2005/10/31 16:43:32  suhrbier
 * addUserToRole() working
 *
 * Revision 1.17  2005/10/31 16:25:35  suhrbier
 * *** empty log message ***
 *
 * Revision 1.16  2005/10/28 23:36:11  suhrbier
 * RoleManager begonnen mit add.
 *
 * Revision 1.15  2005/10/28 10:03:33  suhrbier
 * PolicyManager completed bis auf Comment.
 *
 * Revision 1.14  2005/10/26 15:20:32  suhrbier
 * *** empty log message ***
 *
 * Revision 1.13  2005/10/14 18:30:58  suhrbier
 * *** empty log message ***
 *
 * Revision 1.12  2005/08/20 18:52:04  suhrbier
 * Umstellung auf Target Filterung in PermissionPolicySet
 *
 * Revision 1.11  2005/04/01 22:01:37  suhrbier
 * + RoleManager Assignment Handling fertig.
 *
 * Revision 1.10  2005/04/01 18:22:21  suhrbier
 * Zwischenspeicherung
 *
 * Revision 1.9  2005/04/01 17:58:09  suhrbier
 * + Kommando delete
 *
 * Revision 1.8  2005/04/01 17:42:14  suhrbier
 * + RoleManager add/remove (role)permission(s) und set DefaultPerm
 *
 * Revision 1.7  2005/03/31 18:08:53  suhrbier
 * *** empty log message ***
 *
 * Revision 1.6  2005/03/31 15:19:52  suhrbier
 * + PolicyManager list-Funktionen
 *
 * Revision 1.5  2005/03/30 14:51:32  suhrbier
 * RoleAssignmentPolicy fertiggestellt.
 *
 * Revision 1.4  2005/03/29 15:36:52  suhrbier
 * IdRefPolicyModule implementiert.
 * Fehler in RolePolicySet.getPolicySet behoben
 *
 * Revision 1.3  2005/03/22 19:19:59  suhrbier
 * PEP mit SSL-Login und einfache Rollenzuordnung ber Rollenmanager
 *
 * Revision 1.2  2005/03/08 18:42:37  suhrbier
 * Default Permit korrigiert. Wird jetzt immer am Ende der Rules hinzugefgt.
 * Permit bzw. Deny-Overrides Algorithmus wird angepasst.
 *
 * Revision 1.1  2005/03/07 18:22:31  suhrbier
 * Initiale Version
 *
 * Revision 1.6  2005/03/01 12:43:55  suhrbier
 * Nach Urlaub
 *
 * Revision 1.5  2005/02/10 22:09:58  suhrbier
 * remove perm added
 *
 * Revision 1.4  2005/02/10 22:05:11  suhrbier
 * *** empty log message ***
 *
 * Revision 1.3  2005/02/10 12:33:39  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/02/09 17:16:18  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/02/08 19:16:25  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.profile.rbac;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import nbi.util.FileUtil;
import nbi.util.ReflectionUtil;
import nbi.util.StringUtil;
import nbi.xmlsec.xacml.builder.ConditionTypeBuilder;
import nbi.xmlsec.xacml.util.SyntaxScheme;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.HelpFormatter;
import org.apache.commons.cli.Option;
import org.apache.commons.cli.OptionBuilder;
import org.apache.commons.cli.OptionGroup;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.ParseException;
import org.apache.commons.cli.PosixParser;
import org.apache.commons.configuration.Configuration;
import org.apache.commons.configuration.ConfigurationException;
import org.apache.commons.configuration.ConfigurationFactory;
import org.apache.log4j.Logger;
import org.apache.log4j.xml.DOMConfigurator;

import com.sun.xacml.ParsingException;
import com.sun.xacml.UnknownIdentifierException;
import com.sun.xacml.cond.Apply;
import com.sun.xacml.cond.FunctionTypeException;

/**
 * This class is the main instance of the role management tool. It realises the
 * different commands based on the command line. The role manager has to be
 * configured using the RoleManager part of the configuration file.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.34 $
 * @since
 */
public class RoleManager {
    static Logger logger = Logger.getLogger(RoleManager.class);

    /** The RoleManager's configuration */
    private Configuration configuration;

    /** The RoleManager's PolicyManager */
    private PolicyManager polMgr;

    private static Options options;

    /**
     * Inits the RoleManager based on the given configuration. Depending on the
     * configuration a RoleManger is set up creating the defined default
     * <li>domain</li>,
     * <li>PolicyManager</li>
     * and
     * <li>PolicyFinderModules</li>.
     * 
     * @param config
     *            RoleManager's configuration.
     * @throws Exception
     */
    public RoleManager(Configuration config) throws Exception {
        configuration = config;
        polMgr = (PolicyManager) ReflectionUtil.getInstance(config
                .getString("PolicyManager[@class]"), Configuration.class,
                config.subset("PolicyManager"));
        polMgr.initPolicyFinder();
        initOptions();
    }

    /**
     * Retrieves the policy base directory from the policy manager.
     * 
     * @return The base directory for all policies.
     */
    public String getPolicyBaseDir() {
        return polMgr.getPolicyBaseDir();
    }

    /**
     * Sets the policy base directory to the policy manager.
     * 
     * @return The base directory for all policies.
     */
    public void setPolicyBaseDir(String policyBaseDir) {
        polMgr.setPolicyBaseDir(policyBaseDir);
    }

    /**
     * Retrieves the policy base directory from the current configuration.
     * 
     * @return The base directory for all policies.
     */
    public String getDefaultDomain() {
        return configuration.getString("[@defaultDomain]",
                FileUtil.currentDirectory);
    }

    /**
     * Sets the policy base directory in the current configuration.
     * 
     * @return The base directory for all policies.
     */
    public void setdefaultDomain(String defaultDomain) {
        configuration.addProperty("[@defaultDomain]", defaultDomain);
    }

    /**
     * Determines the domain using the command line. If the command line has the
     * option "D", then this value is returned. Otherwise, the value of the
     * defaultDomain configuration parameter is returned if available. Finally,
     * the currentDirectoryPath (.) is returned.
     * 
     * @return The domain.
     */
    public String getDomainParameter(CommandLine cmd) {
        String domain = null;
        if (cmd.hasOption("D"))
            domain = cmd.getOptionValue("D");
        else
            domain = getDefaultDomain();
        return domain;
    }

    /**
     * Determines the role parameter from the command line.
     * 
     * @return The role parameter or null.
     */
    public String getRoleParameter(CommandLine cmd) {
        String role = null;
        if (cmd.hasOption("R"))
            role = cmd.getOptionValue("R");
        return role;
    }

    /**
     * Gets the Values for the PermissionPolicyParameter from the command line.
     * 
     * @param cmd
     *            Command line to parse
     * @return PermissionPolicy labels from the command line, or null.
     */
    public String[] getPermissionPolicyParameter(CommandLine cmd) {
        String[] result = null;
        if (cmd.hasOption("P"))
            result = cmd.getOptionValues("P");
        return result;
    }

    /**
     * Gets the Values for the PermissionParameter from the command line.
     * 
     * @param cmd
     *            Command line to parse
     * @return Permission labels from the command line, or null.
     */
    public String[] getPermissionParameter(CommandLine cmd) {
        String[] result = null;
        if (cmd.hasOption("p"))
            result = cmd.getOptionValues("p");
        return result;
    }

    /**
     * Gets the permission policies from the command line parameters from the
     * RolePolicySet, or creates and adds new PermissionPolicies to the result
     * list, if they can not be found in the RolePolicySet.
     * 
     * @return List of PermissionPolicies from the command line.
     */
    public List getPermissionPolicies(RolePolicySet policySet, CommandLine cmd) {
        ArrayList result = new ArrayList();
        String domain = getDomainParameter(cmd);
        String permPolicyLabel[] = getPermissionPolicyParameter(cmd);
        if (permPolicyLabel != null) {
            for (int i = 0; i < permPolicyLabel.length; i++) {
                PermissionPolicy permPolicy = policySet.searchPermissionPolicy(
                        domain, permPolicyLabel[i]);
                if (permPolicy == null)
                    permPolicy = new PermissionPolicy(domain,
                            permPolicyLabel[i]);
                result.add(permPolicy);
            }
        }
        return result;
    }

    /**
     * Retrieves the certificates from the User parameter of the command line.
     * When an exception occurs reading a certificate, this certificate is not
     * added to the list. The reading process continues with the next user
     * argument.
     * 
     * @return The list of user certificates read.
     */
    public List getUserCertificates(CommandLine cmd) {
        ArrayList result = new ArrayList();
        String certFile[] = null;
        if (cmd.hasOption("U")) {
            certFile = cmd.getOptionValues("U");
            for (int i = 0; i < certFile.length; i++) {
                try {
                    CertificateFactory cf = CertificateFactory
                            .getInstance("X.509");
                    FileInputStream fis = new FileInputStream(certFile[i]);
                    X509Certificate cert = (X509Certificate) cf
                            .generateCertificate(fis);
                    result.add(cert);
                } catch (CertificateException e) {
                    logger.debug("Error reading certificate from file "
                            + certFile[i] + "." + StringUtil.lineSeparator
                            + "Reason:" + e.getMessage());
                } catch (FileNotFoundException e) {
                    logger.debug("Error reading certificate from file "
                            + certFile[i] + "." + StringUtil.lineSeparator
                            + "Reason:" + e.getMessage());
                }
            }
        }
        return result;
    }

    /**
     * Gets/Creates the current role policy set using the policy manager, the
     * domain and role arguments from the command line and the configuration.
     * 
     * @return The role policy set.
     */
    protected RolePolicySet getRolePolicySet(CommandLine cmd) {
        RolePolicySet result = null;
        String domain = getDomainParameter(cmd);
        String role = getRoleParameter(cmd);
        try {
            result = polMgr.findRolePolicySet(domain, role);
        } catch (ParsingException e) {
            result = new RolePolicySet(domain, role);
        }
        return result;
    }

    /**
     * Gets/Creates the current role assignment policy set using the policy
     * manager, the domain arguments from the command line and the
     * configuration. The label of the RoleAssignmentPolicySet is set to value
     * of the domain label.
     * 
     * @return The role policy set.
     */
    protected RoleAssignmentPolicySet getRoleAssignmentPolicySet(CommandLine cmd) {
        RoleAssignmentPolicySet result = null;
        String domain = getDomainParameter(cmd);
        String role = getRoleParameter(cmd);
        try {
            result = polMgr.findRoleAssignmentPolicySet(domain);
        } catch (ParsingException e) {
            result = new RoleAssignmentPolicySet(domain, domain);
            result.add(new RoleAssignmentPolicy(domain, role));
        }
        return result;
    }

    /**
     * Gets the current permission policy set from a role policy set, or creates
     * a new permission policy set using the domain and role arguments from the
     * command line and the configuration.
     * 
     * @return The permission policy set.
     */
    protected PermissionPolicySet getPermissionPolicySet(
            RolePolicySet policySet, CommandLine cmd) {
        PermissionPolicySet result = null;
        String domain = getDomainParameter(cmd);
        String role = getRoleParameter(cmd);
        result = (PermissionPolicySet) policySet
                .search(new PermissionPolicySetIdentifier(domain, role));
        if (result == null) {
            result = new PermissionPolicySet(domain, role);
        }
        return result;
    }

    /**
     * Gets the assignment from the role assignment policy set, or creates a new
     * from the domain and role arguments from the command line and the
     * configuration.
     * 
     * @return The assignment.
     */
    protected Assignment getAssignment(RoleAssignmentPolicySet policySet,
            CommandLine cmd) {
        Assignment result = null;
        String domain = getDomainParameter(cmd);
        String role = getRoleParameter(cmd);
        result = policySet.searchAssignment(role);
        if (result == null) {
            result = new Assignment(domain, role, new RoleValueIdentifier(
                    domain, role));
            policySet.add(result);
        }
        return result;
    }

    /**
     * Gets the permission labels listed in the CommandLine from the role policy
     * set or creates new permissions from the domain and permission arguments
     * of the command line and the configuration if the permission was not found
     * in the PermissionPolicy.
     * 
     * @return List of permissions from the command line.
     */
    protected List getPermissions(PermissionPolicy permPolicy, CommandLine cmd) {
        ArrayList result = new ArrayList();
        String[] permLabel = null;
        if (cmd.hasOption("p")) {
            permLabel = cmd.getOptionValues("p");
            for (int i = 0; i < permLabel.length; i++) {
                Permission perm = permPolicy.searchPermission(permLabel[i]);
                if (perm == null)
                    perm = new Permission(getDomainParameter(cmd),
                            permLabel[i], getPermissionEffectParameter(cmd));
                result.add(perm);
            }
        }
        return result;
    }

    /**
     * Determines the permission effect parameter from the command line.
     * 
     * @return <code>true</code>, if the permission is set to permit,
     *         <code>false</code>, if the permission is set to deny.
     */
    public boolean getPermissionEffectParameter(CommandLine cmd) {
        boolean result = true;
        if (cmd.hasOption("d"))
            result = false;
        return result;
    }

    /*
     * public boolean create(AbstractPolicy policy) { boolean result = false; if
     * (!polMgr.exists(policy)) { try { polMgr.write(policy); result = true; }
     * catch (IOException e) { logger.error(e.toString()); } catch
     * (ParsingException e) { logger.error(e.toString()); } } return result; }
     * 
     * public boolean delete(AbstractPolicy policy) { boolean result = false;
     * return polMgr.remove(policy); }
     * 
     * public boolean add(RolePolicySetIdentifier roleId,
     * RolePermissionsIdentifier permsId) { boolean result = false; if ((roleId ==
     * null) || (permsId == null)) throw new NullPointerException( "roleId and
     * permsId must not be null"); if (polMgr.exists(roleId)) { try {
     * RolePolicySet role = new RolePolicySet((PolicySet)
     * FilePolicyModule.loadPolicy( roleId.toFile(policyDir).toString(), polMgr
     * .getPolicyFinder())); if (role.add(permsId)) {
     * polMgr.write(role.getPolicySet()); result = true; } } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public boolean add(RoleAssignmentPolicySetIdentifier roleassignId,
     * RoleAssignmentPolicyIdentifier roleassignsId) { boolean result = false;
     * if ((roleassignId == null) || (roleassignsId == null)) throw new
     * NullPointerException( "roleId and permsId must not be null"); if
     * (polMgr.exists(roleassignId)) { try { RoleAssignmentPolicySet roleassign =
     * new RoleAssignmentPolicySet( (PolicySet)
     * FilePolicyModule.loadPolicy(roleassignId .toFile(policyDir).toString(),
     * polMgr .getPolicyFinder())); if (roleassign.add(roleassignsId)) {
     * polMgr.write(roleassign.toPolicySet()); result = true; } } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public boolean remove(RoleAssignmentPolicySetIdentifier roleassignId,
     * RoleAssignmentPolicyIdentifier roleassignsId) { boolean result = false;
     * if ((roleassignId == null) || (roleassignsId == null)) throw new
     * NullPointerException( "roleId and permsId must not be null"); if
     * (polMgr.exists(roleassignId)) { try { RoleAssignmentPolicySet roleassign =
     * new RoleAssignmentPolicySet( (PolicySet)
     * FilePolicyModule.loadPolicy(roleassignId .toFile(policyDir).toString(),
     * polMgr .getPolicyFinder())); if (roleassign.remove(roleassignsId)) {
     * polMgr.write(roleassign.toPolicySet()); result = true; } } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public boolean remove(RolePolicySetIdentifier roleId,
     * RolePermissionsIdentifier permsId) { boolean result = false; if ((roleId ==
     * null) || (permsId == null)) throw new NullPointerException( "roleId and
     * permsId must not be null"); if (polMgr.exists(roleId)) { try {
     * RolePolicySet role = new RolePolicySet((PolicySet)
     * FilePolicyModule.loadPolicy( roleId.toFile(policyDir).toString(), polMgr
     * .getPolicyFinder())); if (role.remove(permsId)) {
     * polMgr.write(role.getPolicySet()); result = true; } } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public boolean add(RolePermissionsIdentifier permsId, Permission perm) {
     * boolean result = false; if ((permsId == null) || (perm == null)) throw
     * new NullPointerException("permsId and perm must not be null"); if
     * (polMgr.exists(permsId)) { try { PermissionPolicySet perms = new
     * PermissionPolicySet( (PolicySet) FilePolicyModule
     * .loadPolicy(permsId.toFile(policyDir) .toString(),
     * polMgr.getPolicyFinder())); if (perms.add(perm)) {
     * polMgr.write(perms.getPolicySet()); result = true; } } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public boolean add(RoleAssignmentPolicyIdentifier assignsId, Assignment
     * assign) { boolean result = false; if ((assignsId == null) || (assign ==
     * null)) throw new NullPointerException( "assignsId and assign must not be
     * null"); if (polMgr.exists(assignsId)) { try { RoleAssignmentPolicy
     * assigns = new RoleAssignmentPolicy( (Policy) FilePolicyModule
     * .loadPolicy(assignsId.toFile(policyDir) .toString(),
     * polMgr.getPolicyFinder())); if (assigns.add(assign)) {
     * polMgr.write(assigns.toPolicy()); result = true; } } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public boolean remove(RolePermissionsIdentifier permsId, Permission perm) {
     * boolean result = false; if ((permsId == null) || (perm == null)) throw
     * new NullPointerException("permsId and perm must not be null"); if
     * (polMgr.exists(permsId)) { try { PermissionPolicySet perms = new
     * PermissionPolicySet( (PolicySet) FilePolicyModule
     * .loadPolicy(permsId.toFile(policyDir) .toString(),
     * polMgr.getPolicyFinder())); if (perms.remove(perm)) {
     * polMgr.write(perms.getPolicySet()); result = true; } } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public boolean remove(RoleAssignmentPolicyIdentifier assignsId,
     * Assignment assign) { boolean result = false; if ((assignsId == null) ||
     * (assign == null)) throw new NullPointerException( "assignsId and assign
     * must not be null"); if (polMgr.exists(assignsId)) { try {
     * RoleAssignmentPolicy assigns = new RoleAssignmentPolicy( (Policy)
     * FilePolicyModule .loadPolicy(assignsId.toFile(policyDir) .toString(),
     * polMgr.getPolicyFinder())); if (assigns.remove(assign)) {
     * polMgr.write(assigns.toPolicy()); result = true; } } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public boolean addPolicySetTarget(RolePermissionsIdentifier permsId,
     * Target policySetTarget) { boolean result = false; if ((permsId == null))
     * throw new NullPointerException("permsId and perm must not be null"); if
     * (polMgr.exists(permsId)) { try { PermissionPolicySet perms = new
     * PermissionPolicySet( (PolicySet) FilePolicyModule
     * .loadPolicy(permsId.toFile(policyDir) .toString(),
     * polMgr.getPolicyFinder()));
     * 
     * perms.addPolicySetTarget(policySetTarget);
     * polMgr.write(perms.getPolicySet()); result = true; } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public boolean set(RolePermissionsIdentifier permsId, boolean permitRule) {
     * boolean result = false; if ((permsId == null)) throw new
     * NullPointerException("permsId and perm must not be null"); if
     * (polMgr.exists(permsId)) { try { PermissionPolicySet perms = new
     * PermissionPolicySet( (PolicySet) FilePolicyModule
     * .loadPolicy(permsId.toFile(policyDir) .toString(),
     * polMgr.getPolicyFinder())); perms.setDefaultPermit(permitRule);
     * polMgr.write(perms.getPolicySet()); result = true; } catch
     * (ParsingException e) { logger.error(e.toString()); } catch
     * (URISyntaxException e) { logger.error(e.toString()); } catch (IOException
     * e) { logger.error(e.toString()); } catch (UnknownIdentifierException e) {
     * logger.error(e.toString()); } catch (FunctionTypeException e) {
     * logger.error(e.toString()); } } return result; }
     * 
     * public static void printHelp(PrintStream out) { out.println("RoleManager
     * commands:"); out.println("list - lists available domains"); out
     * .println("list <domain_id> <type_id> - lists available policies for type
     * a domain"); out .println("create <domain_id> <type_id> <label_id> -
     * creates a new policy <label_id> of type <type_id> in a domain"); out
     * .println("add <domain_id> <role> <label_id> <rolepermission> <label_id> -
     * adds a new policy of type <type_id> to domain <domain>"); out
     * .println("add <domain_id> <rolepermissions> <label_id> <permission>
     * <label_id> <resource_id> <action_id> <permit/deny> - adds a new
     * permission to the rolepermissions to domain <domain>"); out .println("add
     * <domain_id> <roleassignment> <label_id> <roleassignmentPolicies>
     * <label_id> - adds a new policy of type <type_id> to domain <domain>");
     * out .println("add <domain_id> <roleassignmentPolicies> <label_id>
     * <assignment> <label_id> <subject_id> <role_id> - adds a new permission to
     * the rolepermissions to domain <domain>");
     * 
     * out .println("add <domain_id> <rolepermissions> <label_id> <target>
     * <subject/resource/action> <target_value> - adds policyset target value
     * for rolepermissions"); out .println("set <domain_id> <rolepermissions>
     * <label_id> <default> <permit/deny> - sets default permission for
     * rolepermissions"); out .println("remove <domain_id> <rolepermissions>
     * <label_id> <permission> - removes a permission from the rolepermissions
     * to domain <domain>"); out.println("remove role <domain_id> <role_id> -
     * removes role"); out .println("remove perm <perm_id> <domain_id> <role_id> -
     * removes permission from role"); }
     * 
     * private void print(PrintStream out, Identifier[] id) { if (id != null)
     * for (int i = 0; i < id.length; i++) out.println(id[i].getLabel()); }
     * 
     * private void print(PrintStream out, File[] files) { if (files != null)
     * for (int i = 0; i < files.length; i++) out.println(files[i].getName()); }
     * 
     * private void doList(String[] args) throws ParsingException,
     * URISyntaxException { String header; String domain = null; String type =
     * null; if (args.length == 3) { domain = args[1]; type = args[2]; }
     * 
     * if (domain == null) header = "List of domains"; else header = "List of " +
     * type + " for domain " + domain; String headerline =
     * header.replaceAll(".", "="); System.out.println(header);
     * System.out.println(headerline); if (domain == null) print(System.out,
     * polMgr.getDomains()); else { if
     * (type.equals(RolePolicySetIdentifier.TYPEID)) print(System.out,
     * polMgr.listRoleIds(domain)); else if
     * (type.equals(RolePermissionsIdentifier.TYPEID)) print(System.out,
     * polMgr.listRolePermissionsIds(domain)); else if
     * (type.equals(RoleAssignmentPolicySetIdentifier.TYPEID)) print(System.out,
     * polMgr.listRoleAssignmentIds(domain)); else if
     * (type.equals(RoleAssignmentPolicyIdentifier.TYPEID)) print(System.out,
     * polMgr.listRoleAssignmentsIds(domain)); } }
     * 
     * private void doCreate(String[] args) throws FileNotFoundException,
     * ParsingException, URISyntaxException, UnknownIdentifierException,
     * FunctionTypeException { String domain = null; String type = null; String
     * label = null; if (args.length == 4) { domain = args[1]; type = args[2];
     * label = args[3];
     * 
     * boolean result = false; if (type.equals(RolePolicySetIdentifier.TYPEID)) {
     * result = create(new RolePolicySet(domain, label).getPolicySet()); } else
     * if (type.equals(RolePermissionsIdentifier.TYPEID)) { result = create(new
     * PermissionPolicySet(domain, label) .getPolicySet()); } else if
     * (type.equals(RoleAssignmentPolicySetIdentifier.TYPEID)) { result =
     * create(new RoleAssignmentPolicySet(domain, label) .toPolicySet()); } else
     * if (type.equals(RoleAssignmentPolicyIdentifier.TYPEID)) { result =
     * create(new RoleAssignmentPolicy(domain, label).toPolicy()); } else
     * System.out.println("Unknown policy type: " + type); if (result) {
     * System.out.println(type + " policy " + label + " created in domain " +
     * domain + "."); } else System.out.println(type + " policy " + label + "
     * exists or could not be created in domain " + domain + "."); } else
     * printHelp(System.out); }
     * 
     * private void doDelete(String[] args) throws FileNotFoundException,
     * ParsingException, URISyntaxException, UnknownIdentifierException,
     * FunctionTypeException { String domain = null; String type = null; String
     * label = null; if (args.length == 4) { domain = args[1]; type = args[2];
     * label = args[3];
     * 
     * boolean result = false; if (type.equals(RolePolicySetIdentifier.TYPEID)) {
     * result = delete(new RolePolicySet(domain, label).getPolicySet()); } else
     * if (type.equals(RolePermissionsIdentifier.TYPEID)) { result = delete(new
     * PermissionPolicySet(domain, label) .getPolicySet()); } else if
     * (type.equals(RoleAssignmentPolicySetIdentifier.TYPEID)) { result =
     * delete(new RoleAssignmentPolicySet(domain, label) .toPolicySet()); } else
     * if (type.equals(RoleAssignmentPolicyIdentifier.TYPEID)) { result =
     * delete(new RoleAssignmentPolicy(domain, label).toPolicy()); } else
     * System.out.println("Unknown policy type: " + type); if (result) {
     * System.out.println(type + " policy " + label + " removed from domain " +
     * domain + "."); } else System.out .println(type + " policy " + label + "
     * does not exist or could not be removed from domain " + domain + "."); }
     * else printHelp(System.out); }
     * 
     * private void doAddRoleAssignments(String[] args) throws
     * FileNotFoundException, ParsingException, URISyntaxException,
     * UnknownIdentifierException, FunctionTypeException { String domain = null;
     * String assignment = null; String assignments = null; if (args.length ==
     * 6) { domain = args[1]; assignment = args[3]; assignments = args[5];
     * 
     * boolean result = false; RoleAssignmentPolicySetIdentifier assignmentId =
     * new RoleAssignmentPolicySetIdentifier( domain, assignment);
     * RoleAssignmentPolicyIdentifier assignmentsId = new
     * RoleAssignmentPolicyIdentifier( domain, assignments); if
     * (add(assignmentId, assignmentsId)) {
     * System.out.println("roleassignmentPolicies " + assignments + " added to
     * roleassignment " + assignment + " in domain " + domain + "."); } else
     * System.out.println("roleassignmentPolicies " + assignments + " exists or
     * could not be added to roleassignment " + assignment + " in domain " +
     * domain + "."); } else printHelp(System.out); }
     * 
     * private void doRemoveRoleAssignments(String[] args) throws
     * FileNotFoundException, ParsingException, URISyntaxException,
     * UnknownIdentifierException, FunctionTypeException { String domain = null;
     * String assignment = null; String assignments = null; if (args.length ==
     * 6) { domain = args[1]; assignment = args[3]; assignments = args[5];
     * 
     * boolean result = false; RoleAssignmentPolicySetIdentifier assignmentId =
     * new RoleAssignmentPolicySetIdentifier( domain, assignment);
     * RoleAssignmentPolicyIdentifier assignmentsId = new
     * RoleAssignmentPolicyIdentifier( domain, assignments); if
     * (remove(assignmentId, assignmentsId)) {
     * System.out.println("roleassignmentPolicies " + assignments + " removed
     * from roleassignment " + assignment + " in domain " + domain + "."); }
     * else System.out .println("roleassignmentPolicies " + assignments + " does
     * not exist or could not be removed from roleassignment " + assignment + "
     * in domain " + domain + "."); } else printHelp(System.out); }
     * 
     * private void doAddRolePermissionsPolicySetTarget(String[] args) throws
     * FileNotFoundException, ParsingException, URISyntaxException,
     * UnknownIdentifierException, FunctionTypeException { String domain = null;
     * String roleperms = null; String targetType = null; String targetValue =
     * null; if (args.length == 7) { domain = args[1]; roleperms = args[3];
     * targetType = args[5]; targetValue = args[6];
     * 
     * TargetMatchBuilder targetMatchBuilder = null; TargetBuilder targetBuilder =
     * new TargetBuilder(); if ("subject".equals(targetType)) {
     * targetMatchBuilder = new SubjectMatchBuilder(
     * EqualFunction.NAME_STRING_EQUAL, StringAttribute.identifier, new
     * StringAttribute( targetValue));
     * targetBuilder.addSubject(targetMatchBuilder.getInstance()); } else if
     * ("resource".equals(targetType)) { targetMatchBuilder = new
     * ResourceMatchBuilder( EqualFunction.NAME_STRING_EQUAL,
     * StringAttribute.identifier, new StringAttribute( targetValue));
     * targetBuilder.addResource(targetMatchBuilder.getInstance()); } else if
     * ("action".equals(targetType)) { targetMatchBuilder = new
     * ActionMatchBuilder( EqualFunction.NAME_STRING_EQUAL,
     * StringAttribute.identifier, new StringAttribute( targetValue));
     * targetBuilder.addAction(targetMatchBuilder.getInstance()); }
     * 
     * boolean result = false; RolePermissionsIdentifier rolepermsId = new
     * RolePermissionsIdentifier( domain, roleperms);
     * 
     * if (addPolicySetTarget(rolepermsId, targetBuilder.getInstance())) {
     * System.out.println("target " + targetType + " " + targetValue + "added to
     * rolepermissions " + roleperms + " in domain " + domain + "."); } else
     * System.out.println("target " + targetType + " " + targetValue + " exists
     * or could not be added to role " + roleperms + " in domain " + domain +
     * "."); } else printHelp(System.out); }
     * 
     * private void doAddRolePermissions(String[] args) throws
     * FileNotFoundException, ParsingException, URISyntaxException,
     * UnknownIdentifierException, FunctionTypeException { String domain = null;
     * String role = null; String roleperms = null; if (args.length == 6) {
     * domain = args[1]; role = args[3]; roleperms = args[5];
     * 
     * boolean result = false; RolePolicySetIdentifier roleId = new
     * RolePolicySetIdentifier(domain, role); RolePermissionsIdentifier
     * rolepermsId = new RolePermissionsIdentifier( domain, roleperms); if
     * (add(roleId, rolepermsId)) { System.out.println("rolepermissions " +
     * roleperms + " added to role " + role + " in domain " + domain + "."); }
     * else System.out.println("rolepermissions " + roleperms + " exists or
     * could not be added to role " + role + " in domain " + domain + "."); }
     * else printHelp(System.out); }
     * 
     * private void doRemoveRolePermissions(String[] args) throws
     * FileNotFoundException, ParsingException, URISyntaxException,
     * UnknownIdentifierException, FunctionTypeException { String domain = null;
     * String role = null; String roleperms = null; if (args.length == 6) {
     * domain = args[1]; role = args[3]; roleperms = args[5];
     * 
     * boolean result = false; RolePolicySetIdentifier roleId = new
     * RolePolicySetIdentifier(domain, role); RolePermissionsIdentifier
     * rolepermsId = new RolePermissionsIdentifier( domain, roleperms); if
     * (remove(roleId, rolepermsId)) { System.out.println("rolepermissions " +
     * roleperms + " removed from role " + role + " in domain " + domain + "."); }
     * else System.out.println("rolepermissions " + roleperms + " do not exist
     * or could not be removed from role " + role + " in domain " + domain +
     * "."); } else printHelp(System.out); }
     * 
     * //add <domain_id> <rolepermissions> <label_id> <permission> <label_id> //
     * <resource_id> <action_id> <permit/deny> - adds a new permission to the //
     * rolepermissions to domain <domain>");
     * 
     * private void doAddPermission(String[] args) throws FileNotFoundException,
     * ParsingException, URISyntaxException, UnknownIdentifierException,
     * FunctionTypeException { String domain = null; String roleperms = null;
     * String perm = null; String resources = null; String actions = null;
     * boolean permit = false; if (args.length == 9) { domain = args[1];
     * roleperms = args[3]; perm = args[5]; resources = args[6]; actions =
     * args[7]; permit = args[8].equals("permit") ? true : false;
     * 
     * boolean result = false; RolePermissionsIdentifier rolepermsId = new
     * RolePermissionsIdentifier( domain, roleperms); Permission permission =
     * new Permission(domain, perm, permit); PermissionResource permResource =
     * new PermissionResource(resources); PermissionAction permAction = new
     * PermissionAction(actions); permission.add(permResource);
     * permission.add(permAction); if (add(rolepermsId, permission)) {
     * System.out.println("permission " + perm + " added to rolepermissions " +
     * roleperms + " in domain " + domain + "."); } else
     * System.out.println("permission " + perm + " exists or could not be added
     * to rolepermissions " + roleperms + " in domain " + domain + "."); } else
     * printHelp(System.out); }
     * 
     * private void doRemovePermission(String[] args) throws
     * FileNotFoundException, ParsingException, URISyntaxException,
     * UnknownIdentifierException, FunctionTypeException { String domain = null;
     * String roleperms = null; String perm = null; if (args.length == 6) {
     * domain = args[1]; roleperms = args[3]; perm = args[5];
     * 
     * boolean result = false; RolePermissionsIdentifier rolepermsId = new
     * RolePermissionsIdentifier( domain, roleperms); Permission permission =
     * new Permission(domain, perm, true); if (remove(rolepermsId, permission)) {
     * System.out.println("permission " + perm + " removed from rolepermissions " +
     * roleperms + " in domain " + domain + "."); } else System.out
     * .println("permission " + perm + " do not exist or could not be removed
     * from rolepermissions " + roleperms + " in domain " + domain + "."); }
     * else printHelp(System.out); }
     * 
     * private void doAddAssignment(String[] args) throws FileNotFoundException,
     * ParsingException, URISyntaxException, UnknownIdentifierException,
     * FunctionTypeException { String domain = null; String roleassigns = null;
     * String assign = null; String subjects = null; String resources = null; if
     * (args.length == 8) { domain = args[1]; roleassigns = args[3]; assign =
     * args[5]; subjects = args[6]; resources = args[7];
     * 
     * boolean result = false; RoleAssignmentPolicyIdentifier roleassignsId =
     * new RoleAssignmentPolicyIdentifier( domain, roleassigns); Assignment
     * assignment = new Assignment(domain, assign, true); AssignmentSubject
     * assignSubject = new AssignmentSubject(subjects); AssignmentResource
     * assignResource = new AssignmentResource( new RoleValueIdentifier(domain,
     * resources).toString()); assignment.add(assignSubject);
     * assignment.add(assignResource); if (add(roleassignsId, assignment)) {
     * System.out.println("assignment" + assign + " added to
     * roleassignmentPolicies " + roleassigns + " in domain " + domain + "."); }
     * else System.out.println("assignment " + assign + " exists or could not be
     * added to roleassignmentPolicies" + roleassigns + " in domain " + domain +
     * "."); } else printHelp(System.out); }
     * 
     * private void doRemoveAssignment(String[] args) throws
     * FileNotFoundException, ParsingException, URISyntaxException,
     * UnknownIdentifierException, FunctionTypeException { String domain = null;
     * String roleassigns = null; String assign = null; String subjects = null;
     * String resources = null; if (args.length == 6) { domain = args[1];
     * roleassigns = args[3]; assign = args[5];
     * 
     * boolean result = false; RoleAssignmentPolicyIdentifier roleassignsId =
     * new RoleAssignmentPolicyIdentifier( domain, roleassigns); Assignment
     * assignment = new Assignment(domain, assign, true); if
     * (remove(roleassignsId, assignment)) { System.out.println("assignment" +
     * assign + " removed from roleassignmentPolicies " + roleassigns + " in
     * domain " + domain + "."); } else System.out .println("assignment " +
     * assign + " exists or could not be removed from roleassignmentPolicies" +
     * roleassigns + " in domain " + domain + "."); } else
     * printHelp(System.out); } // set <domain_id> <rolepermissions> <label_id>
     * <default> <permit/deny> - // adds a new policy of type <type_id> to
     * domain <domain>"); private void doSetDefaultPermit(String[] args) throws
     * FileNotFoundException, ParsingException, URISyntaxException,
     * UnknownIdentifierException, FunctionTypeException { String domain = null;
     * String roleperms = null; boolean permit = false; if (args.length == 6) {
     * domain = args[1]; roleperms = args[3]; permit = (args[5].equals("permit") ?
     * true : false);
     * 
     * boolean result = false; RolePermissionsIdentifier rolepermsId = new
     * RolePermissionsIdentifier( domain, roleperms); if (set(rolepermsId,
     * permit)) { System.out.println("default-permission set to " + (permit ?
     * "permit" : "deny") + " for rolepermissions " + roleperms + " in domain " +
     * domain + "."); } else System.out .println("default-permission could not
     * be set for rolepermissions " + roleperms + " in domain " + domain + "."); }
     * else printHelp(System.out); }
     */

    private void initOptions() {
        options = new Options();
        OptionGroup cmds = new OptionGroup();
        cmds.addOption(new Option("l", "list", false, "list policy items"));
        cmds
                .addOption(new Option("a", "add", false,
                        "add/update policy items"));
        cmds.addOption(new Option("r", "remove", false, "remove policy items"));
        cmds.addOption(new Option("h", "help", false, "print this message"));

        options.addOptionGroup(cmds);

        options.addOption(OptionBuilder.withLongOpt("policyBaseDir")
                .withDescription("specifies the policy base directory")
                .withValueSeparator('=').hasArg().create());

        options
                .addOption(OptionBuilder
                        .withLongOpt("Deny")
                        .withDescription(
                                "Sets Permissions effect to deny or sets the combining algorithm of a PermissionPolicy or PermissionPolicySet to deny-overrides")
                        .create("d"));

        options.addOption(OptionBuilder.withLongOpt("Domain").withDescription(
                "specifies at least one domains").hasArg(true).withArgName(
                "<label list>").create("D"));

        options.addOption(OptionBuilder.withLongOpt("PermissionPolicy")
                .withDescription("specifies at least one PermissionPolicy")
                .hasArgs().withArgName("<label list>").create("P"));
        options.addOption(OptionBuilder.withLongOpt("Permission")
                .withDescription("specifies at least one piece of Permission")
                .hasArgs().withArgName("<label list>").create("p"));
        options.addOption(OptionBuilder.withLongOpt("Condition")
                .withDescription(
                        "specifies the Condition of a piece of Permission")
                .hasArg().withArgName(
                        "<syntax scheme(<datatype-func[value1,value2,...]>)>")
                .create("C"));

        options.addOption(OptionBuilder.withLongOpt("Role").withDescription(
                "specifies at least one role").hasArg(true).withArgName(
                "<label list>").create("R"));
        options.addOption(OptionBuilder.withLongOpt("User").withDescription(
                "specifies at least one path to an X.509 certificate file")
                .hasArgs().withArgName("<certificate file list>").create("U"));

        options
                .addOption(OptionBuilder.withLongOpt("targetResource")
                        .withDescription(
                                "specifies at least one XACML resource target")
                        .hasArgs().withArgName("<datatype- matchfunc[value]>")
                        .create("y"));
        options.addOption(OptionBuilder.withLongOpt("targetAction")
                .withDescription("specifies at least one XACML action target")
                .hasArgs().withArgName("<datatype- matchfunc[value]>").create(
                        "z"));
    }

    private void printErrorMsg(String msg, String reason) {
        System.err
                .println(msg + StringUtil.lineSeparator + "Reason: " + reason);
    }

    private void printMsg(String msg) {
        System.out.println(msg);
    }

    /**
     * Prints the elements of a collection to a stream. The method calls the
     * {@link Object#toString() toString()}method of every element in the
     * collection. The elements are separated by the string sep. If
     * <code>sep</code> is <code>null</code>, no separation is done.
     * Optionally, a headerline may be printed.
     * 
     * @param out
     *            PrintStream to print the collection to.
     * @param coll
     *            The collection to print.
     * @param sep
     *            The separator string to separate the collection's elements or
     *            <code>null</code>, if separation is not wanted.
     * @param headerLine
     *            The headerline to print or <code>null</code>, if a
     *            headerline is not wanted.
     */
    private void printCollection(PrintStream out, Collection coll, String sep,
            String headerLine) {
        StringBuffer printBuf = new StringBuffer();
        printBuf.append(StringUtil.lineSeparator);
        if (headerLine != null) {
            printBuf.append(headerLine + StringUtil.lineSeparator);
            for (int i = 0; i < headerLine.length(); i++)
                printBuf.append("=");
            printBuf.append(StringUtil.lineSeparator);
        }
        if (coll != null) {
            Iterator collIt = coll.iterator();
            if (sep == null)
                sep = "";
            while (collIt.hasNext()) {
                printBuf.append(collIt.next().toString());
                if (collIt.hasNext())
                    printBuf.append(sep);
            }
        }
        printBuf.append(StringUtil.lineSeparator);
        out.print(printBuf);
    }

    /**
     * Extracts the labels from a list of identifiers.
     * 
     * @param ids
     *            List of Identifiers.
     * @return List of labels extracted from the identifier list.
     */
    private List getLabels(List ids) {
        List labels = new ArrayList();
        Iterator idIt = ids.iterator();
        while (idIt.hasNext()) {
            labels.add(((Identifier) idIt.next()).getLabel());
        }
        return labels;
    }

    private void doHelp(CommandLine cmd) {
        HelpFormatter formatter = new HelpFormatter();
        formatter.printHelp("RoleManager", options);
    }

    private void doList(CommandLine cmd) {
        String domain = getDomainParameter(cmd);

        if (cmd.hasOption("R") && cmd.hasOption("P")) {
            ArrayList list = new ArrayList();
            String[] permPolicyLabel = getPermissionPolicyParameter(cmd);
            for (int i = 0; i < permPolicyLabel.length; i++) {
                try {
                    PermissionPolicy permPolicy = polMgr.findPermissionPolicy(
                            domain, permPolicyLabel[i]);
                    if (permPolicy != null)
                        list.add(permPolicy);
                } catch (ParsingException e) {
                }
            }
            printCollection(System.out, list, StringUtil.lineSeparator, "Role "
                    + getRoleParameter(cmd) + " in Domain "
                    + getDomainParameter(cmd) + " has " + list.size()
                    + " PermissionPolicies");
        } else if (cmd.hasOption("R")) {
            RoleAssignmentPolicySet roleAssignPolicySet = getRoleAssignmentPolicySet(cmd);
            ArrayList assignmentLabels = new ArrayList();
            Iterator roleAssignIt;
            if (roleAssignPolicySet.getAssignments() != null) {
                roleAssignIt = roleAssignPolicySet.getAssignments().iterator();

                while (roleAssignIt.hasNext()) {
                    Assignment assign = (Assignment) roleAssignIt.next();
                    if (assign.getSubjects() != null) {
                        Iterator assignIt = assign.getSubjects().iterator();
                        while (assignIt.hasNext())
                            assignmentLabels.add(assignIt.next().toString());
                    }
                }
                printCollection(System.out, assignmentLabels,
                        StringUtil.lineSeparator, "Role "
                                + getRoleParameter(cmd) + " in Domain "
                                + getDomainParameter(cmd) + " has "
                                + assignmentLabels.size() + " Assignments");
            }

            RolePolicySet rolePolicySet = getRolePolicySet(cmd);
            ArrayList permPolicyLabels = new ArrayList();
            Iterator permPolicyIt;
            if (rolePolicySet.getPermissionPolicies() != null) {
                permPolicyIt = rolePolicySet.getPermissionPolicies().iterator();

                while (permPolicyIt.hasNext())
                    permPolicyLabels.add(((PermissionPolicy) permPolicyIt
                            .next()).getIdentifier().getLabel());
                printCollection(System.out, permPolicyLabels,
                        StringUtil.lineSeparator, "Role "
                                + getRoleParameter(cmd) + " in Domain "
                                + getDomainParameter(cmd) + " has "
                                + rolePolicySet.getPermissionPolicies().size()
                                + " PermissionPolicies");
            }
        } else if (cmd.hasOption("D")) {
            List roleAssignPolicySet = polMgr.getIdentifiers(
                    getDomainParameter(cmd),
                    RoleAssignmentPolicySetIdentifier.TYPEID);
            List rolePolicySet = polMgr.getIdentifiers(getDomainParameter(cmd),
                    RolePolicySetIdentifier.TYPEID);

            if (roleAssignPolicySet != null) {
                List labels = new ArrayList(roleAssignPolicySet.size());
                Iterator roleAssignPolicyIt = roleAssignPolicySet.iterator();
                while (roleAssignPolicyIt.hasNext())
                    labels
                            .add(((RoleAssignmentPolicySetIdentifier) roleAssignPolicyIt
                                    .next()).getLabel());
                printCollection(System.out, labels, StringUtil.lineSeparator,
                        "Domain " + getDomainParameter(cmd) + " has "
                                + roleAssignPolicySet.size()
                                + " RoleAssignmentPolicySets");
            }

            if (rolePolicySet != null) {
                List labels = new ArrayList(rolePolicySet.size());
                Iterator rolePolicyIt = rolePolicySet.iterator();
                while (rolePolicyIt.hasNext())
                    labels.add(((RolePolicySetIdentifier) rolePolicyIt.next())
                            .getLabel());
                printCollection(System.out, labels, StringUtil.lineSeparator,
                        "Domain " + getDomainParameter(cmd) + " has "
                                + roleAssignPolicySet.size()
                                + " RolePolicySets");
            }
        } else
            printCollection(System.out, polMgr.getDomains(),
                    StringUtil.lineSeparator, "Domains");

    }

    private void doAdd(CommandLine cmd) {
        if (cmd.hasOption("R") && cmd.hasOption("U"))
            doAddUserToRole(cmd);
        else if (cmd.hasOption("R") && cmd.hasOption("P")) {
            if (cmd.hasOption("p"))
                doAddPermissionToPermissionPolicy(cmd);
            else
                doAddPermissionPolicyToRole(cmd);
        }
    }

    private Permission doAddConditionToPermission(Permission perm,
            CommandLine cmd) throws ParsingException,
            UnknownIdentifierException, FunctionTypeException {
        if (cmd.hasOption("C")) {
            String target = cmd.getOptionValue("C");
            if (target != null) {
                perm.setCondition(new ConditionTypeBuilder(new SyntaxScheme(
                        target)));
            }
        }
        return perm;
    }

    private void doAddPermissionToPermissionPolicy(CommandLine cmd) {
        RolePolicySet rolePolicySet = getRolePolicySet(cmd);
        Iterator permPolicyIt = getPermissionPolicies(rolePolicySet, cmd)
                .iterator();
        while (permPolicyIt.hasNext()) {
            PermissionPolicy permPolicy = (PermissionPolicy) permPolicyIt
                    .next();
            Iterator permIt = getPermissions(permPolicy, cmd).iterator();
            while (permIt.hasNext()) {
                Permission perm = (Permission) permIt.next();
                perm.setPermit(getPermissionEffectParameter(cmd));
                try {
                    perm = doAddConditionToPermission(perm, cmd);
                } catch (Exception e) {
                    printErrorMsg("Error adding Condition "
                            + cmd.getOptionValue("C") + " to Permission "
                            + perm.getIdentifier().getLabel()
                            + " of permission policy "
                            + permPolicy.getIdentifier().getLabel()
                            + " of role "
                            + rolePolicySet.getIdentifier().getLabel()
                            + " in domain "
                            + rolePolicySet.getIdentifier().getDomain(), e
                            .getMessage());
                }
                if (cmd.hasOption("y")) {
                    String[] target = cmd.getOptionValues("y");
                    if (target != null) {
                        for (int y = 0; y < target.length; y++)
                            perm.addResource(target[y]);
                    }
                }
                if (cmd.hasOption("z")) {
                    String[] action = cmd.getOptionValues("z");
                    if (action != null) {
                        for (int z = 0; z < action.length; z++)
                            perm.addAction(action[z]);
                    }
                }

                if (permPolicy.add(perm))
                    printMsg("Permission " + perm.getIdentifier().getLabel()
                            + " added or updated to permission policy "
                            + permPolicy.getIdentifier().getLabel()
                            + " of role "
                            + rolePolicySet.getIdentifier().getLabel()
                            + " in domain "
                            + rolePolicySet.getIdentifier().getDomain());
                else
                    printMsg("Permission " + perm.getIdentifier().getLabel()
                            + " already member of permission policy "
                            + permPolicy.getIdentifier().getLabel()
                            + " of role "
                            + rolePolicySet.getIdentifier().getLabel()
                            + " in domain "
                            + rolePolicySet.getIdentifier().getDomain());
            }
            rolePolicySet.add(permPolicy);
        }
        try {
            rolePolicySet.encode(new File(polMgr.getPolicyBaseDir()));
        } catch (IOException e) {
            printErrorMsg("Error adding permissions " + " to role "
                    + rolePolicySet.getIdentifier().getLabel() + " in domain "
                    + rolePolicySet.getIdentifier().getDomain(), e.getMessage());
        }
    }

    private void doAddPermissionPolicyToRole(CommandLine cmd) {
        RolePolicySet rolePolicySet = getRolePolicySet(cmd);
        Iterator permPolicyIt = getPermissionPolicies(rolePolicySet, cmd)
                .iterator();
        while (permPolicyIt.hasNext()) {
            PermissionPolicy permPolicy = (PermissionPolicy) permPolicyIt
                    .next();
            permPolicy.setPermitRule(!cmd.hasOption("d"));
            if (rolePolicySet.add(permPolicy)) {
                printMsg("PermissionPolicy "
                        + permPolicy.getIdentifier().getLabel()
                        + " added or updated to the role"
                        + rolePolicySet.getIdentifier().getLabel()
                        + " in domain "
                        + rolePolicySet.getIdentifier().getDomain());
            } else
                printMsg("PermissionPolicy "
                        + permPolicy.getIdentifier().getLabel()
                        + " already member of role "
                        + rolePolicySet.getIdentifier().getLabel()
                        + " in domain "
                        + rolePolicySet.getIdentifier().getDomain());
        }
        try {
            rolePolicySet.encode(new File(polMgr.getPolicyBaseDir()));
        } catch (IOException e) {
            printErrorMsg("Error updating PermissionPolicies.", e.getMessage());
        }
    }

    private void doAddUserToRole(CommandLine cmd) {
        RoleAssignmentPolicySet rolePolicySet = getRoleAssignmentPolicySet(cmd);
        Assignment assign = getAssignment(rolePolicySet, cmd);
        Iterator certIt = getUserCertificates(cmd).iterator();
        while (certIt.hasNext()) {
            X509Certificate cert = ((X509Certificate) certIt.next());
            if (assign.add(cert.getSubjectX500Principal())) {
                printMsg("User " + cert.getSubjectX500Principal().toString()
                        + " added to role " + getRoleParameter(cmd)
                        + " in domain " + getDomainParameter(cmd));
            } else
                printMsg("User " + cert.getSubjectX500Principal().toString()
                        + " already member of role " + getRoleParameter(cmd)
                        + " in domain " + getDomainParameter(cmd));
        }
        try {
            rolePolicySet.add(assign);
            rolePolicySet.encode(new File(polMgr.getPolicyBaseDir()));
            printMsg("Policy update successful.");
        } catch (IOException e) {
            printErrorMsg("Error updating policy.", e.getMessage());
        }
    }

    private void doRemove(CommandLine cmd) {
        if (cmd.hasOption("R") && cmd.hasOption("U"))
            doRemoveUserFromRole(cmd);
        else if (cmd.hasOption("R") && cmd.hasOption("P"))
            if (cmd.hasOption("p"))
                if (cmd.hasOption("C"))
                    doRemoveConditionFromPermission(cmd);
                else
                    doRemovePermissionFromPermissionPolicy(cmd);
            else
                doRemovePermissionPolicyFromRole(cmd);
        else if (cmd.hasOption("R"))
            doRemoveRole(cmd);
        else if (cmd.hasOption("D"))
            doRemoveDomain(cmd);
    }

    private void doRemoveRole(CommandLine cmd) {
        try {
            RolePolicySet rolePolicySet = getRolePolicySet(cmd);
            Iterator permPolicySetIt = rolePolicySet.getElements().iterator();
            while (permPolicySetIt.hasNext()) {
                PermissionPolicySet permPolicySet = (PermissionPolicySet) permPolicySetIt
                        .next();
                Iterator permPolicyIt = permPolicySet.getElements().iterator();
                while (permPolicyIt.hasNext()) {
                    PermissionPolicy permPolicy = (PermissionPolicy) permPolicyIt
                            .next();
                    if (polMgr.remove(permPolicy.getIdentifier()))
                        printMsg("PermissionPolicy "
                                + permPolicy.getIdentifier().getLabel()
                                + " removed from file system "
                                + permPolicy.getIdentifier().toFile(
                                        polMgr.getPolicyBaseDir())
                                + " in domain "
                                + rolePolicySet.getIdentifier().getDomain());
                    else
                        printMsg("PermissionPolicy "
                                + permPolicy.getIdentifier().getLabel()
                                + " already removed from file system "
                                + permPolicy.getIdentifier().toFile(
                                        polMgr.getPolicyBaseDir())
                                + " in domain "
                                + rolePolicySet.getIdentifier().getDomain());
                }
                if (polMgr.remove(permPolicySet.getIdentifier()))
                    printMsg("PermissionPolicySet "
                            + permPolicySet.getIdentifier().getLabel()
                            + " removed from file system "
                            + permPolicySet.getIdentifier().toFile(
                                    polMgr.getPolicyBaseDir()) + " in domain "
                            + rolePolicySet.getIdentifier().getDomain());
                else
                    printMsg("PermissionPolicySet "
                            + permPolicySet.getIdentifier().getLabel()
                            + " already removed from file system "
                            + permPolicySet.getIdentifier().toFile(
                                    polMgr.getPolicyBaseDir()) + " in domain "
                            + rolePolicySet.getIdentifier().getDomain());

            }
            if (polMgr.remove(rolePolicySet.getIdentifier()))
                printMsg("RolePolicySet "
                        + rolePolicySet.getIdentifier().getLabel()
                        + " removed from file system "
                        + rolePolicySet.getIdentifier().toFile(
                                polMgr.getPolicyBaseDir()) + " in domain "
                        + rolePolicySet.getIdentifier().getDomain());
            else
                printMsg("RolePolicySet "
                        + rolePolicySet.getIdentifier().getLabel()
                        + " already removed from file system "
                        + rolePolicySet.getIdentifier().toFile(
                                polMgr.getPolicyBaseDir()) + " in domain "
                        + rolePolicySet.getIdentifier().getDomain());

            RoleAssignmentPolicySet roleAssignPolicySet = getRoleAssignmentPolicySet(cmd);
            Iterator roleAssignPolicyIt = roleAssignPolicySet.getElements()
                    .iterator();
            while (roleAssignPolicyIt.hasNext()) {
                RoleAssignmentPolicy roleAssignPolicy = (RoleAssignmentPolicy) roleAssignPolicyIt
                        .next();
                if (polMgr.remove(roleAssignPolicy.getIdentifier()))
                    printMsg("RoleAssignmentPolicy "
                            + roleAssignPolicy.getIdentifier().getLabel()
                            + " removed from file system "
                            + roleAssignPolicy.getIdentifier().toFile(
                                    polMgr.getPolicyBaseDir()) + " in domain "
                            + roleAssignPolicySet.getIdentifier().getDomain());
                else
                    printMsg("RoleAssignmentPolicy "
                            + roleAssignPolicy.getIdentifier().getLabel()
                            + " already removed from file system "
                            + roleAssignPolicy.getIdentifier().toFile(
                                    polMgr.getPolicyBaseDir()) + " in domain "
                            + roleAssignPolicySet.getIdentifier().getDomain());
            }
            if (polMgr.remove(roleAssignPolicySet.getIdentifier()))
                printMsg("RoleAssignPolicySet "
                        + roleAssignPolicySet.getIdentifier().getLabel()
                        + " removed from file system "
                        + roleAssignPolicySet.getIdentifier().toFile(
                                polMgr.getPolicyBaseDir()) + " in domain "
                        + roleAssignPolicySet.getIdentifier().getDomain());
            else
                printMsg("RoleAssignPolicySet "
                        + roleAssignPolicySet.getIdentifier().getLabel()
                        + " already removed from file system "
                        + roleAssignPolicySet.getIdentifier().toFile(
                                polMgr.getPolicyBaseDir()) + " in domain "
                        + roleAssignPolicySet.getIdentifier().getDomain());

        } catch (ParsingException e) {
            printErrorMsg("Error removing Role " + getRoleParameter(cmd), e
                    .getMessage());
        }

    }

    private void doRemoveDomain(CommandLine cmd) {
        polMgr.removeDomain(getDomainParameter(cmd));
    }

    private void doRemovePermissionPolicyFromRole(CommandLine cmd) {
        RolePolicySet rolePolicySet = getRolePolicySet(cmd);
        Iterator permPolicyIt = getPermissionPolicies(rolePolicySet, cmd)
                .iterator();
        while (permPolicyIt.hasNext()) {
            PermissionPolicy permPolicy = (PermissionPolicy) permPolicyIt
                    .next();
            Iterator permIt = getPermissions(permPolicy, cmd).iterator();
            if (rolePolicySet.remove(permPolicy)) {
                printMsg("PermissionPolicy "
                        + permPolicy.getIdentifier().getLabel()
                        + " removed from role "
                        + rolePolicySet.getIdentifier().getLabel()
                        + " in domain "
                        + rolePolicySet.getIdentifier().getDomain());
            } else
                printMsg("PermissionPolicy "
                        + permPolicy.getIdentifier().getLabel()
                        + " not member of role "
                        + rolePolicySet.getIdentifier().getLabel()
                        + " in domain "
                        + rolePolicySet.getIdentifier().getDomain());
        }
        try {
            rolePolicySet.encode(new File(polMgr.getPolicyBaseDir()));
        } catch (IOException e) {
            printErrorMsg("Error removing PermissionPolicies. ", e.getMessage());
        }
    }

    private void doRemoveConditionFromPermission(CommandLine cmd) {
        RolePolicySet rolePolicySet = getRolePolicySet(cmd);
        String domain = getDomainParameter(cmd);
        String[] permPolicyLabel = getPermissionPolicyParameter(cmd);
        if (permPolicyLabel != null) {
            for (int i = 0; i < permPolicyLabel.length; i++) {
                PermissionPolicy permPolicy = rolePolicySet
                        .searchPermissionPolicy(domain, permPolicyLabel[i]);
                if (permPolicy != null) {
                    String[] permLabel = getPermissionParameter(cmd);
                    if (permLabel != null) {
                        for (int j = 0; j < permLabel.length; j++) {
                            Permission perm = permPolicy
                                    .searchPermission(permLabel[j]);
                            if (perm != null) {
                                if (cmd.hasOption("c")) {
                                    if (perm.getCondition() != null) {
                                        perm.setCondition((Apply) null);
                                        printMsg("Condition removed from permission "
                                                + perm.getIdentifier()
                                                        .getLabel()
                                                + " of permission policy"
                                                + permPolicy.getIdentifier()
                                                        .getLabel()
                                                + " of role "
                                                + rolePolicySet.getIdentifier()
                                                        .getLabel()
                                                + " in domain "
                                                + rolePolicySet.getIdentifier()
                                                        .getDomain());
                                    } else
                                        printMsg("No condition to remove from permission "
                                                + perm.getIdentifier()
                                                        .getLabel()
                                                + " of permission policy"
                                                + permPolicy.getIdentifier()
                                                        .getLabel()
                                                + " of role "
                                                + rolePolicySet.getIdentifier()
                                                        .getLabel()
                                                + " in domain "
                                                + rolePolicySet.getIdentifier()
                                                        .getDomain());

                                }
                            }
                        }
                    }
                }
            }
        }

        try {
            rolePolicySet.encode(new File(polMgr.getPolicyBaseDir()));
        } catch (IOException e) {
            printErrorMsg("Error removing permissions " + " from role "
                    + rolePolicySet.getIdentifier().getLabel() + " in domain "
                    + rolePolicySet.getIdentifier().getDomain(), e.getMessage());
        }
    }

    private void doRemovePermissionFromPermissionPolicy(CommandLine cmd) {
        RolePolicySet rolePolicySet = getRolePolicySet(cmd);
        String domain = getDomainParameter(cmd);
        String[] permPolicyLabel = getPermissionPolicyParameter(cmd);
        if (permPolicyLabel != null) {
            for (int i = 0; i < permPolicyLabel.length; i++) {
                PermissionPolicy permPolicy = rolePolicySet
                        .searchPermissionPolicy(domain, permPolicyLabel[i]);
                if (permPolicy != null) {
                    String[] permLabel = getPermissionParameter(cmd);
                    if (permLabel != null) {
                        for (int j = 0; j < permLabel.length; j++) {
                            Permission perm = permPolicy
                                    .searchPermission(permLabel[j]);
                            if (perm != null) {
                                if (!cmd.hasOption("y") && !cmd.hasOption("z")) {
                                    if (permPolicy.remove(perm))
                                        printMsg("Permission "
                                                + perm.getIdentifier()
                                                        .getLabel()
                                                + " removed from permission policy "
                                                + permPolicy.getIdentifier()
                                                        .getLabel()
                                                + " of role "
                                                + rolePolicySet.getIdentifier()
                                                        .getLabel()
                                                + " in domain "
                                                + rolePolicySet.getIdentifier()
                                                        .getDomain());
                                    else
                                        printMsg("Permission "
                                                + perm.getIdentifier()
                                                        .getLabel()
                                                + " not member of permission policy "
                                                + permPolicy.getIdentifier()
                                                        .getLabel()
                                                + " of role "
                                                + rolePolicySet.getIdentifier()
                                                        .getLabel()
                                                + " in domain "
                                                + rolePolicySet.getIdentifier()
                                                        .getDomain());
                                } else {
                                    if (cmd.hasOption("y")) {
                                        String[] target = cmd
                                                .getOptionValues("y");
                                        if (target != null) {
                                            for (int y = 0; y < target.length; y++) {
                                                if (perm
                                                        .removeResource(target[y]))
                                                    printMsg("TargetResource "
                                                            + target[y]
                                                            + " removed from Permission "
                                                            + perm
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " of PermissionPolicy "
                                                            + permPolicy
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " of role "
                                                            + rolePolicySet
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " in domain "
                                                            + rolePolicySet
                                                                    .getIdentifier()
                                                                    .getDomain());
                                                else
                                                    printMsg("TargetResource "
                                                            + target[y]
                                                            + " not member of Permission "
                                                            + perm
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " of PermissionPolicy "
                                                            + permPolicy
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " of role "
                                                            + rolePolicySet
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " in domain "
                                                            + rolePolicySet
                                                                    .getIdentifier()
                                                                    .getDomain());
                                            }
                                        }
                                    }
                                    if (cmd.hasOption("z")) {
                                        String[] target = cmd
                                                .getOptionValues("z");
                                        if (target != null) {
                                            for (int z = 0; z < target.length; z++) {
                                                if (perm
                                                        .removeAction(target[z]))
                                                    printMsg("TargetAction "
                                                            + target[z]
                                                            + " removed from Permission "
                                                            + perm
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " of PermissionPolicy "
                                                            + permPolicy
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " of role "
                                                            + rolePolicySet
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " in domain "
                                                            + rolePolicySet
                                                                    .getIdentifier()
                                                                    .getDomain());
                                                else
                                                    printMsg("TargetAction "
                                                            + target[z]
                                                            + " not member of Permission "
                                                            + perm
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " of PermissionPolicy "
                                                            + permPolicy
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " of role "
                                                            + rolePolicySet
                                                                    .getIdentifier()
                                                                    .getLabel()
                                                            + " in domain "
                                                            + rolePolicySet
                                                                    .getIdentifier()
                                                                    .getDomain());
                                            }
                                        }
                                    }
                                }
                            } else
                                printMsg("Permission "
                                        + permLabel[j]
                                        + " not member of permission policy "
                                        + permPolicy.getIdentifier().getLabel()
                                        + " of role "
                                        + rolePolicySet.getIdentifier()
                                                .getLabel()
                                        + " in domain "
                                        + rolePolicySet.getIdentifier()
                                                .getDomain());
                        }
                    }
                } else
                    printMsg("PermissionPolicy " + permPolicyLabel[i]
                            + " not member of role "
                            + rolePolicySet.getIdentifier().getLabel()
                            + " in domain "
                            + rolePolicySet.getIdentifier().getDomain());
            }
        }
        try {
            rolePolicySet.encode(new File(polMgr.getPolicyBaseDir()));
        } catch (IOException e) {
            printErrorMsg("Error removing permissions " + " from role "
                    + rolePolicySet.getIdentifier().getLabel() + " in domain "
                    + rolePolicySet.getIdentifier().getDomain(), e.getMessage());
        }
    }

    private void doRemoveUserFromRole(CommandLine cmd) {
        RoleAssignmentPolicySet rolePolicySet = getRoleAssignmentPolicySet(cmd);
        Assignment assign = getAssignment(rolePolicySet, cmd);
        Iterator certIt = getUserCertificates(cmd).iterator();
        while (certIt.hasNext()) {
            X509Certificate cert = ((X509Certificate) certIt.next());
            if (assign.remove(cert.getSubjectX500Principal())) {
                printMsg("User " + cert.getSubjectX500Principal().toString()
                        + " removed from role " + getRoleParameter(cmd)
                        + " in domain " + getDomainParameter(cmd));
            } else
                printMsg("User " + cert.getSubjectX500Principal().toString()
                        + " not member of role " + getRoleParameter(cmd)
                        + " in domain " + getDomainParameter(cmd));
        }
        try {
            rolePolicySet.add(assign);
            rolePolicySet.encode(new File(polMgr.getPolicyBaseDir()));
            printMsg("Policy update successful.");
        } catch (IOException e) {
            printErrorMsg("Error updating policy.", e.getMessage());
        }
    }

    public void doCmd(CommandLine cmd) {
        initOptions();
        if (cmd.hasOption("policyBaseDir"))
            polMgr.setPolicyBaseDir(cmd.getOptionValue("policyBaseDir"));

        if (cmd.hasOption("h"))
            doHelp(cmd);
        else if (cmd.hasOption("l"))
            doList(cmd);
        else if (cmd.hasOption("a"))
            doAdd(cmd);
        else if (cmd.hasOption("r"))
            doRemove(cmd);
    }

    public void doCmd(String args[]) throws ParseException {
        CommandLineParser parser = new PosixParser();
        CommandLine cmd = parser.parse(options, args);
        doCmd(cmd);
    }

    public static void main(String[] args) throws Exception {
        // Shut down the java.util.logging used from sunxacml
        java.util.logging.LogManager.getLogManager().reset();

        DOMConfigurator.configure("log4j.xml");
        try {
            ConfigurationFactory factory = new ConfigurationFactory(
                    "config.xml");
            Configuration config = factory.getConfiguration();
            RoleManager roleMgr = new RoleManager(config.subset("RoleManager"));
            roleMgr.doCmd(args);
        } catch (ConfigurationException e) {
            logger.error(e.getMessage());
        } catch (ParseException e) {
            System.err.println("Command parsing failed. Reason: "
                    + e.getMessage());
        }
    }

    /*
     * public static void main(String[] args) throws Exception {
     * DOMConfigurator.configure("log4j.xml"); if (args.length == 0) {
     * printHelp(System.out); } else { RoleManager rMgr = new
     * RoleManager("policies"); if (args[0].equals("list")) { rMgr.doList(args); }
     * else if (args[0].equals("create")) { rMgr.doCreate(args); } else if
     * (args[0].equals("delete")) { rMgr.doDelete(args); } else if
     * (args[0].equals("add")) { if
     * (args[2].equals(RolePolicySetIdentifier.TYPEID))
     * rMgr.doAddRolePermissions(args); else if
     * (args[2].equals(RolePermissionsIdentifier.TYPEID)) { if
     * (args[4].equals("target"))
     * rMgr.doAddRolePermissionsPolicySetTarget(args); else
     * rMgr.doAddPermission(args); } else if
     * (args[2].equals(RoleAssignmentPolicySetIdentifier.TYPEID))
     * rMgr.doAddRoleAssignments(args); else if
     * (args[2].equals(RoleAssignmentPolicyIdentifier.TYPEID))
     * rMgr.doAddAssignment(args); } else if (args[0].equals("remove")) { if
     * (args[2].equals(RolePolicySetIdentifier.TYPEID))
     * rMgr.doRemoveRolePermissions(args); else if
     * (args[2].equals(RolePermissionsIdentifier.TYPEID))
     * rMgr.doRemovePermission(args); else if
     * (args[2].equals(RoleAssignmentPolicySetIdentifier.TYPEID))
     * rMgr.doRemoveRoleAssignments(args); else if
     * (args[2].equals(RoleAssignmentPolicyIdentifier.TYPEID))
     * rMgr.doRemoveAssignment(args); } else if (args[0].equals("set")) { if
     * (args[2].equals(RolePermissionsIdentifier.TYPEID) &&
     * args[4].equals("default")) rMgr.doSetDefaultPermit(args); } else {
     * System.err.println("Unknown command " + args[0] + "."); } } }
     */
}