/*
 * $Id: RolePolicySet.java,v 1.9 2006/07/24 17:31:10 suhrbier Exp $
 * Created on 28.01.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: RolePolicySet.java,v $
 * Revision 1.9  2006/07/24 17:31:10  suhrbier
 * update JavaDoc
 *
 * Revision 1.8  2005/12/06 17:12:15  suhrbier
 * list Befehl implementiert und getestet.
 * Fehler bei Domains der auf den DirectoryFileFitler von commons.io zurckgeht.
 *
 * Revision 1.7  2005/12/05 19:05:48  suhrbier
 * RoleManager tested, but list command.
 *
 * Revision 1.6  2005/12/05 19:04:04  suhrbier
 * RoleManager tested, but list command.
 *
 * Revision 1.5  2005/12/05 11:26:08  suhrbier
 * *** empty log message ***
 *
 * Revision 1.4  2005/11/07 20:21:36  suhrbier
 * *** empty log message ***
 *
 * Revision 1.3  2005/11/07 10:59:41  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/11/03 21:15:03  suhrbier
 * Add/Remove PermissionPolicy To Role
 *
 * Revision 1.1  2005/11/02 20:10:33  suhrbier
 * RolePolicySet ready. Start with RoleManager for Permissions.
 *
 * Revision 1.8  2005/10/14 18:30:58  suhrbier
 * *** empty log message ***
 *
 * Revision 1.7  2005/10/07 17:05:51  suhrbier
 * Beginn Umbau XACML-Builder.
 *
 * Revision 1.6  2005/04/01 17:42:14  suhrbier
 * + RoleManager add/remove (role)permission(s) und set DefaultPerm
 *
 * Revision 1.5  2005/03/30 14:51:32  suhrbier
 * RoleAssignmentPolicy fertiggestellt.
 *
 * Revision 1.4  2005/03/29 17:47:52  suhrbier
 * last edit: Assignment
 *
 * Revision 1.3  2005/03/29 15:36:52  suhrbier
 * IdRefPolicyModule implementiert.
 * Fehler in RolePolicySet.getPolicySet behoben
 *
 * Revision 1.2  2005/03/24 20:01:18  suhrbier
 * Erzeugen von RBAC-Policies nach V2.0, Schreiben in Verzeichnisstruktur.
 * Es fehlt noch:
 * - checken des Einlesens
 * - PolicyFindetModule um die IdReferences einzulesen
 *
 * Revision 1.1  2005/03/07 18:22:32  suhrbier
 * Initiale Version
 *
 * Revision 1.12  2005/03/01 12:43:55  suhrbier
 * Nach Urlaub
 *
 * Revision 1.11  2005/02/10 12:33:39  suhrbier
 * *** empty log message ***
 *
 * Revision 1.10  2005/02/09 17:16:18  suhrbier
 * *** empty log message ***
 *
 * Revision 1.9  2005/02/08 19:16:25  suhrbier
 * *** empty log message ***
 *
 * Revision 1.8  2005/02/08 17:51:31  suhrbier
 * *** empty log message ***
 *
 * Revision 1.7  2005/02/08 12:17:15  suhrbier
 * *** empty log message ***
 *
 * Revision 1.6  2005/02/07 17:37:52  suhrbier
 * *** empty log message ***
 *
 * Revision 1.5  2005/02/05 17:12:48  suhrbier
 * *** empty log message ***
 *
 * Revision 1.4  2005/02/03 17:30:10  suhrbier
 * *** empty log message ***
 *
 * Revision 1.3  2005/02/02 17:20:10  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/01/31 18:01:35  suhrbier
 * RBAC Policy Writer
 *
 * Revision 1.1  2005/01/28 15:51:19  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.profile.rbac;

import java.net.URI;
import java.util.Iterator;
import java.util.Set;

import nbi.util.StringUtil;
import nbi.xmlsec.xacml.profile.rbac.builder.RolePolicySetTargetMatchBuilderFactory;
import nbi.xmlsec.xacml.profile.rbac.parser.RolePolicySetTargetMatchParserFactory;
import nbi.xmlsec.xacml.util.TargetUtil;

import com.sun.xacml.ParsingException;
import com.sun.xacml.PolicySet;
import com.sun.xacml.PolicyTreeElement;
import com.sun.xacml.Target;
import com.sun.xacml.TargetMatch;

/**
 * This class implements a role policy set according to the XACML RBAC Profile.
 * It stores the permission policy set and may be represented as a
 * {@link PolicySet PolicySet}or parsed from a {@link PolicySet PolicySet}
 * representation.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.9 $
 * @since
 */

public class RolePolicySet extends RBACPolicySet {

    public final static String ATTRIBUTE_ID = "urn:oasis:names:tc:xacml:2.0:subject:role";

    /**
     * Creates a role policy set from its identifier. The default policy
     * representation type is set to
     * {@link RBACPolicySet#REPRESENT_POLICIES_AS_POLICYREF REPRESENT_POLICIES_AS_POLICYREF}.
     * 
     * @param domain
     *            Identifier's domain.
     * @param label
     *            Identifier's label.
     */
    public RolePolicySet(String domain, String label) {
        super(new RolePolicySetIdentifier(domain, label),
                REPRESENT_POLICIES_AS_POLICYREF);
        setTarget(new RBACTarget(RolePolicySetTargetMatchBuilderFactory
                .getInstance(), RolePolicySetTargetMatchParserFactory
                .getInstance()));
        getTarget().addSubject(
                new RoleValueIdentifier(getIdentifier().getDomain(),
                        getIdentifier().getLabel()).toURI());
        add(new PermissionPolicySet(getIdentifier().getDomain(),
                getIdentifier().getLabel()));
    }

    /**
     * Creates a role policy set from its identifier. The default policy
     * representation type is set to
     * {@link RBACPolicySet#REPRESENT_POLICIES_AS_POLICYREF REPRESENT_POLICIES_AS_POLICYREF}.
     * 
     * @param id
     *            Identifier's URI representation.
     */
    public RolePolicySet(URI id) throws ParsingException {
        super(Identifier.getInstance(id), REPRESENT_POLICIES_AS_POLICYREF);
        setTarget(new RBACTarget(RolePolicySetTargetMatchBuilderFactory
                .getInstance(), RolePolicySetTargetMatchParserFactory
                .getInstance()));
        getTarget().addSubject(
                new RoleValueIdentifier(getIdentifier().getDomain(),
                        getIdentifier().getLabel()).toURI());
        add(new PermissionPolicySet(getIdentifier().getDomain(),
                getIdentifier().getLabel()));
    }

    /**
     * Creates a role policy set from its {@link PolicySet PolicySet}
     * representation. The first policy parsed determines the policy
     * representation type of the policy set.
     * 
     * @param policySet
     *            {@link PolicySet PolicySet}representation.
     */
    public RolePolicySet(PolicySet policySet) throws ParsingException {
        setTarget(new RBACTarget(RolePolicySetTargetMatchBuilderFactory
                .getInstance(), RolePolicySetTargetMatchParserFactory
                .getInstance()));
        parse(policySet);
    }

    /**
     * Parses the target of an RolePolicySet.
     * 
     * @see RBACPolicySet#parse(Target)
     */
    public void parse(Target target) throws ParsingException {
        if ((TargetUtil.getTargetMatchSize(target, TargetMatch.SUBJECT) != 1)
                || (TargetUtil.getTargetMatchSize(target, TargetMatch.RESOURCE) > 0)
                || (TargetUtil.getTargetMatchSize(target, TargetMatch.ACTION) > 0))
            throw new ParsingException("Target subject of the RolePolicySet "
                    + getIdentifier().toString()
                    + " should only contain the role subject.");
        getTarget().parse(target);
    }

    /**
     * Parses a role policy set from its {@link PolicySet PolicySet}
     * representation. The first policy parsed determines the policy
     * representation type of the policy set.
     * 
     * @param element
     *            The policy set to parse.
     * @throws ParsingException
     *             Indicates errors during the parsing process.
     */
    public void parse(PolicyTreeElement element) throws ParsingException {
        super.parse(element, null, PermissionPolicySet.class,
                PermissionPolicySet.class);
        if ((elements == null) || (elements.size() != 1))
            throw new ParsingException(
                    "RolePolicySet must only contain one element.");
        if (getTarget().getSubjects().size() != 1)
            throw new ParsingException(
                    "RolePolicySet must only contain one target subject.");
        if (!getTarget().getSubjects().contains(
                new RoleValueIdentifier(getIdentifier().getDomain(),
                        getIdentifier().getLabel()).toURI()))
            throw new ParsingException(
                    "RolePolicySet must contain one target subject with the role's identifier.");
    }

    /**
     * Retrieves the permission policy set of this role policy set.
     * 
     * @param domain
     *            The domain to search for.
     * @return The permission policy set from this role policy set or
     *         <code>null</code>.
     * @see RBACPolicy#search(Identifier).
     */
    public PermissionPolicySet searchPermissionPolicySet(String domain) {
        return (PermissionPolicySet) search(new PermissionPolicySetIdentifier(
                domain, getIdentifier().getLabel()));
    }

    /**
     * Retrieves an permission policy of the permission policy set from that
     * role.
     * 
     * @param domain
     *            The domain to search for.
     * @param label
     *            The name of the permission policy to search for.
     * @return The permission policy from the permission policy set or
     *         <code>null</code>.
     * @see RBACPolicy#search(Identifier).
     */
    public PermissionPolicy searchPermissionPolicy(String domain, String label) {
        PermissionPolicy result = null;
        PermissionPolicySet policySet = searchPermissionPolicySet(domain);
        if (policySet != null)
            result = (PermissionPolicy) policySet
                    .search(new PermissionPolicyIdentifier(domain, label));
        return result;
    }

    /**
     * Retrieves a permission from an permission policy of the permission policy
     * set from that role.
     * 
     * @param domain
     *            The domain to search for.
     * @param policy
     *            The name of the permission policy to search for.
     * @param label
     *            The name of the permission to search for.
     * @return The permission from the permission policy or <code>null</code>.
     * @see RBACPolicy#search(Identifier).
     */
    public Permission searchPermission(String domain, String policy,
            String label) {
        Permission result = null;
        PermissionPolicy permPolicy = searchPermissionPolicy(domain, policy);
        if (permPolicy != null)
            result = (Permission) permPolicy.search(new PermissionIdentifier(
                    domain, label));
        return result;
    }

    /**
     * Gets the label of this role from the identifier.
     * 
     * @return label of this role
     */
    public String getRole() {
        return getIdentifier().getLabel();
    }

    /**
     * Adds the permission policy to the permission policy set of this role
     * policy set.
     * 
     * @param element
     *            The permission policy to add.
     * @return <code>true</code>, if the element was succesfully added or
     *         successfully updates an existing element, <code>false</code>
     *         otherwise.
     * @see RBACPolicy#add(RBACPolicyElement)
     */
    public boolean add(PermissionPolicy element) {
        boolean result = false;
        PermissionPolicySet policySet = searchPermissionPolicySet(getIdentifier()
                .getDomain());
        if (policySet != null)
            result = policySet.add(element);
        return result;
    }

    /**
     * Removes the permission policy to the permission policy set of this role
     * policy set.
     * 
     * @param element
     *            The permission policy to remove.
     * @return <code>true</code>, if the element was succesfully removed,
     *         <code>false</code> otherwise.
     * @see RBACPolicy#add(RBACPolicyElement)
     */
    public boolean remove(PermissionPolicy element) {
        boolean result = false;
        PermissionPolicySet policySet = searchPermissionPolicySet(getIdentifier()
                .getDomain());
        if (policySet != null)
            result = policySet.remove(element);
        return result;
    }

    /**
     * Adds the permission to the given permission policy of this role policy
     * set.
     * 
     * @param id
     *            The identifier of the permission policy to add to.
     * @param element
     *            The permission to add.
     * @return <code>true</code>, if the element was succesfully added or
     *         successfully updates an existing element, <code>false</code>
     *         otherwise.
     * @throws ParsingException
     * @see RBACPolicy#remove(RBACPolicyElement).
     */
    public boolean add(PermissionPolicyIdentifier id, Permission element) {
        boolean result = false;
        PermissionPolicy policy = searchPermissionPolicy(id.getDomain(), id
                .getLabel());
        try {

            if (policy == null)
                policy = new PermissionPolicy(id.toURI());
            result = policy.add(element);
        } catch (ParsingException e) {
            result = false;
        }
        return result;
    }

    /**
     * Removes the permission from the given permission policy of this role
     * policy set.
     * 
     * @param id
     *            The identifier of the permission policy to remove from.
     * @param element
     *            The permission to remove.
     * @return <code>true</code>, if the element was succesfully added or
     *         successfully updates an existing element, <code>false</code>
     *         otherwise.
     * @see RBACPolicy#remove(RBACPolicyElement).
     */
    public boolean remove(PermissionPolicyIdentifier id, Permission element) {
        boolean result = false;
        PermissionPolicy policy = searchPermissionPolicy(id.getDomain(), id
                .getLabel());
        if (policy != null)
            result = policy.remove(element);
        return result;
    }

    /**
     * Gets the PermissionPolicySet of this RolePolicySet. The first element of
     * the elements set is returned.
     * 
     * @return PermissionPolicySet or null, if no elements available.
     */
    public PermissionPolicySet getPermissionPolicySet() {
        PermissionPolicySet result = null;
        if ((getElements() != null) && (!getElements().isEmpty()))
            result = (PermissionPolicySet) getElements().toArray()[0];
        return result;
    }

    public Set getPermissionPolicies() {
        Set result = null;
        PermissionPolicySet permPolicySet = getPermissionPolicySet();
        if (permPolicySet != null)
            result = permPolicySet.getElements();
        return result;
    }

    public String toString() {
        StringBuffer result = new StringBuffer();
        result.append(getIdentifier().toString());
        result.append(" PermissionsPolicies ");
        if (getPermissionPolicies() == null)
            result.append("0");
        else {
            result.append(getPermissionPolicies().size());
            result.append(StringUtil.lineSeparator);
            Iterator it = getPermissionPolicies().iterator();
            while (it.hasNext()) {
                result.append(it.next().toString());
                result.append(StringUtil.lineSeparator);
            }
        }
        return result.toString();
    }

}
