/*
 * $Id: TrustedClientRoleIdentifier.java,v 1.1 2006/05/31 14:55:20 suhrbier Exp $
 * Created on 23.09.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: TrustedClientRoleIdentifier.java,v $
 * Revision 1.1  2006/05/31 14:55:20  suhrbier
 * *** empty log message ***
 *
 * Revision 1.4  2005/12/14 15:34:31  suhrbier
 * Neue Policies scheinen jetzt zu laufen...
 *
 * Revision 1.3  2005/11/02 20:10:33  suhrbier
 * RolePolicySet ready. Start with RoleManager for Permissions.
 *
 * Revision 1.2  2005/10/12 19:49:00  suhrbier
 * Identifier classes revised and JavaDoc.
 *
 * Revision 1.1  2005/09/23 19:11:12  suhrbier
 * Jetty Anbindung bis auf Parameter fertig.
 *
 */
package nbi.xmlsec.xacml.profile.rbac;

/**
 * Implementation of a role identifier for the trustedClient role.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.1 $
 * @since 
 */

public class TrustedClientRoleIdentifier extends RoleAssignmentPolicyIdentifier {
    public static String ROLE_LABEL = "trustedClient";

    /**
     * Creates a role identifier for the role trustedClient in the given domain.
     * @param domain Domain for the trustedClient role.
     */
    public TrustedClientRoleIdentifier(String domain) {
        super(domain, ROLE_LABEL);
    }
}
