/* $Id: PermissionTargetMatchBuilderFactory.java,v 1.2 2005/11/04 17:52:36 suhrbier Exp $
 * Created on 15.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: PermissionTargetMatchBuilderFactory.java,v $
 * Revision 1.2  2005/11/04 17:52:36  suhrbier
 * Permission add mit Targets funzt.
 *
 * Revision 1.1  2005/11/01 18:45:19  suhrbier
 * Permission upgedated.
 *
 * Revision 1.2  2005/10/24 09:38:39  suhrbier
 * Assignment test ok
 *
 * Revision 1.1  2005/10/15 21:37:40  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.profile.rbac.builder;

import nbi.xmlsec.xacml.builder.TargetMatchBuilder;
import nbi.xmlsec.xacml.builder.TargetMatchBuilderFactory;

import org.apache.log4j.Logger;

import com.sun.xacml.TargetMatch;

/**
 * Implements a Singleton TargetMatchBuilderFactory for Permission targets.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since
 */
public class PermissionTargetMatchBuilderFactory extends
        TargetMatchBuilderFactory {

    static Logger logger = Logger.getLogger(PermissionTargetMatchBuilderFactory.class);
    private static PermissionTargetMatchBuilderFactory factory = null;

    private PermissionTargetMatchBuilderFactory() {
    }

    public static PermissionTargetMatchBuilderFactory getInstance() {
        if (factory == null) {
            factory = new PermissionTargetMatchBuilderFactory();
            factory.registerResourceMatchBuilder(String.class,
                    new PermissionMatchBuilder(TargetMatch.RESOURCE));
            factory.registerActionMatchBuilder(String.class,
                    new PermissionMatchBuilder(TargetMatch.ACTION));
        }
        return factory;
    }
    public TargetMatchBuilder getInstance(int type, Object obj) {
        PermissionMatchBuilder result = (PermissionMatchBuilder)super.getInstance(type,obj);
        try
        {
            result.setAttribute((String)obj);
        }
        catch(Exception e)
        {
            logger.debug("This should never happen: "+e.getMessage());
        }
        return result; 
    }
    
}
