/*
 * $Id: PDPPolicyFinderModule.java,v 1.2 2005/12/14 15:34:31 suhrbier Exp $
 * Created on 04.04.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: PDPPolicyFinderModule.java,v $
 * Revision 1.2  2005/12/14 15:34:31  suhrbier
 * Neue Policies scheinen jetzt zu laufen...
 *
 * Revision 1.1  2005/12/09 11:01:28  suhrbier
 * 2 special PolicyFinder fr REA und PDP
 *
 * Revision 1.4  2005/11/01 11:50:45  suhrbier
 * RoleManager add, remove and list of users completed.
 *
 * Revision 1.3  2005/10/28 10:03:33  suhrbier
 * PolicyManager completed bis auf Comment.
 *
 * Revision 1.2  2005/10/27 18:26:05  suhrbier
 * RBACPolicyFinderModule completed.
 *
 * Revision 1.1  2005/10/27 10:21:04  suhrbier
 * *** empty log message ***
 *
 * Revision 1.2  2005/07/25 15:30:07  suhrbier
 * HttpInputStream updated.
 *
 * Revision 1.1  2005/04/04 21:23:23  suhrbier
 * Erste lauffhige Version mit RoleEnableAuth und RBACPDP
 *
 * Revision 1.1  2005/04/04 17:20:56  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.profile.rbac.finder;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;

import nbi.xmlsec.xacml.profile.rbac.RolePolicySetIdentifier;

import org.apache.commons.configuration.Configuration;
import org.apache.log4j.Logger;

import com.sun.xacml.finder.PolicyFinder;
import com.sun.xacml.finder.PolicyFinderModule;

/**
 * Implementation of the PDP policy finder module for the RBAC profile.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since
 */

public class PDPPolicyFinderModule extends RBACPolicyFinderModule {

    private static final Logger logger = Logger
            .getLogger(PDPPolicyFinderModule.class);

    /**
     * @param config
     *            Configuration of the type <code>PolicyFinderModule</code>
     *            for this module.
     */
    public PDPPolicyFinderModule(Configuration config) {
        super(config);
    }

    /**
     * Inits this PolicyFinder loading all policy files with the given file
     * suffixes from the RoleAssignmentPolicySet and RoleAssignmentPolicy
     * subdirectories of the policy base dir.
     * 
     * @see PolicyFinderModule#init(PolicyFinder)
     */
    public void init(PolicyFinder finder) {
        this.policyFinder = finder;
        ArrayList policyDir = new ArrayList(2);
        policyDir
                .add(new File(getPolicyBaseDir() + File.separator + getDomain()
                        + File.separator + RolePolicySetIdentifier.TYPEID));
/*
        policyDir.add(new File(getPolicyBaseDir() + File.separator
                + getDomain() + File.separator
                + PermissionPolicySetIdentifier.TYPEID));
        policyDir.add(new File(getPolicyBaseDir() + File.separator
                + getDomain() + File.separator
                + PermissionPolicyIdentifier.TYPEID));
*/                
        Iterator policyDirIt = policyDir.iterator();
        while (policyDirIt.hasNext())
            this.policies.addAll(loadPolicies((File) policyDirIt.next(),
                    getPolicyFileFilter(), policyFinder));
    }
}
