/* $Id: AssignmentTargetMatchParserFactory.java,v 1.1 2005/10/18 18:15:55 suhrbier Exp $
 * Created on 15.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: AssignmentTargetMatchParserFactory.java,v $
 * Revision 1.1  2005/10/18 18:15:55  suhrbier
 * RoleAssignment Umstellung abgeschlossen!
 *
 * Revision 1.1  2005/10/15 21:37:40  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.profile.rbac.parser;

import java.net.URI;

import nbi.xmlsec.xacml.parser.TargetMatchParserFactory;
import nbi.xmlsec.xacml.parser.X500NameMatchParser;

import com.sun.xacml.attr.AnyURIAttribute;
import com.sun.xacml.attr.X500NameAttribute;

/**
 * Implements a Singleton TargetMatchParserFactory for Assignment targets.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.1 $
 * @since
 */
public class AssignmentTargetMatchParserFactory extends
        TargetMatchParserFactory {

    private static AssignmentTargetMatchParserFactory factory = null;

    private AssignmentTargetMatchParserFactory() {
    }

    public static AssignmentTargetMatchParserFactory getInstance() {
        if (factory == null) {
            factory = new AssignmentTargetMatchParserFactory();
            factory.registerSubjectMatchParser(URI.create(X500NameAttribute.identifier),
                    new X500NameMatchParser());
            factory.registerResourceMatchParser(URI.create(AnyURIAttribute.identifier),
                    new RoleMatchParser());
            factory.registerActionMatchParser(URI.create(AnyURIAttribute.identifier),
                    new EnableRoleMatchParser());
        }
        return factory;
    }
}
