/*
 * $Id: EnableRoleMatchParser.java,v 1.2 2005/12/19 19:11:05 suhrbier Exp $
 * Created on 18.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: EnableRoleMatchParser.java,v $
 * Revision 1.2  2005/12/19 19:11:05  suhrbier
 * Version ready to be delivered to BGBM.
 *
 * Revision 1.1  2005/10/18 18:15:55  suhrbier
 * RoleAssignment Umstellung abgeschlossen!
 *
 */
package nbi.xmlsec.xacml.profile.rbac.parser;

import java.net.URI;

import nbi.xmlsec.xacml.parser.AnyURIMatchParser;
import nbi.xmlsec.xacml.profile.rbac.Assignment;

import com.sun.xacml.ParsingException;
import com.sun.xacml.TargetMatch;

/**
 * Parses an RoleValueIdentifier match value from a target match
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since
 */

public class EnableRoleMatchParser extends AnyURIMatchParser {

    /**
     * 
     */
    public EnableRoleMatchParser() {
        super();
    }
    /**
     * Inits the match parser.
     * 
     * @param targetMatch
     *            The target match to parse.
     */
    public EnableRoleMatchParser(TargetMatch targetMatch) {
        super(targetMatch);
    }

    /**
     * Checks, if the match value contains the
     * {@link Assignment#enableRoleActionId Assignment.enableRoleActionId}.
     * 
     * @return <code>null</code>, if the attribute does not contain
     *         {@link Assignment#enableRoleActionId Assignment.enableRoleActionId},
     *         otherwise
     *         {@link Assignment#enableRoleActionId Assignment.enableRoleActionId}.
     * 
     * @see nbi.xmlsec.xacml.parser.TargetMatchParser#parseMatchValue()
     */
    public Object parseMatchValue() throws ParsingException {
        URI result = (URI) super.parseMatchValue();
        if (!result.equals(Assignment.enableRoleActionId))
            result = null;
        return result;
    }
}
