/* $Id: PermissionTargetMatchParserFactory.java,v 1.2 2005/11/04 17:52:36 suhrbier Exp $
 * Created on 15.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: PermissionTargetMatchParserFactory.java,v $
 * Revision 1.2  2005/11/04 17:52:36  suhrbier
 * Permission add mit Targets funzt.
 *
 * Revision 1.1  2005/11/01 18:45:19  suhrbier
 * Permission upgedated.
 *
 * Revision 1.1  2005/10/18 18:15:55  suhrbier
 * RoleAssignment Umstellung abgeschlossen!
 *
 * Revision 1.1  2005/10/15 21:37:40  suhrbier
 * *** empty log message ***
 *
 */
package nbi.xmlsec.xacml.profile.rbac.parser;

import java.net.URI;

import nbi.xmlsec.xacml.parser.TargetMatchParserFactory;

import com.sun.xacml.attr.StringAttribute;

/**
 * Implements a Singleton TargetMatchParserFactory for Assignment targets.
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.2 $
 * @since
 */
public class PermissionTargetMatchParserFactory extends
        TargetMatchParserFactory {

    private static PermissionTargetMatchParserFactory factory = null;

    private PermissionTargetMatchParserFactory() {
    }

    public static PermissionTargetMatchParserFactory getInstance() {
        if (factory == null) {
            factory = new PermissionTargetMatchParserFactory();
            factory.registerResourceMatchParser(URI.create(StringAttribute.identifier),
                    new PermissionMatchParser());
            factory.registerActionMatchParser(URI.create(StringAttribute.identifier),
                    new PermissionMatchParser());
        }
        return factory;
    }
}
