/*
 * $Id: RolePolicySetMatchParser.java,v 1.4 2005/12/19 19:11:05 suhrbier Exp $
 * Created on 18.10.2005
 *
 ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * "The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is XML Security Services for BioCASE Provider Software.
 * 
 * The Initial Developer of the Original Code is 
 * Lutz Suhrbier (suhrbier@inf.fu-berlin.de)
 * Networked Information Systems
 * Department of Mathematics and Computer Science
 * Freie Universitt Berlin
 * Takustrasse 9
 * D-14195 Berlin.
 * 
 * Portions created by the Initial Developer are Copyright (C) 2004-2006
 * by the Initial Developer. All Rights Reserved.
 * 
 * Contributor(s):
 *
 ***** END LICENSE BLOCK *****
 * 
 * $Log: RolePolicySetMatchParser.java,v $
 * Revision 1.4  2005/12/19 19:11:05  suhrbier
 * Version ready to be delivered to BGBM.
 *
 * Revision 1.3  2005/12/14 15:34:31  suhrbier
 * Neue Policies scheinen jetzt zu laufen...
 *
 * Revision 1.2  2005/11/03 21:15:03  suhrbier
 * Add/Remove PermissionPolicy To Role
 *
 * Revision 1.1  2005/11/02 20:10:33  suhrbier
 * RolePolicySet ready. Start with RoleManager for Permissions.
 *
 * Revision 1.2  2005/10/21 17:43:03  suhrbier
 * *** empty log message ***
 *
 * Revision 1.1  2005/10/18 18:15:55  suhrbier
 * RoleAssignment Umstellung abgeschlossen!
 *
 */
package nbi.xmlsec.xacml.profile.rbac.parser;

import java.net.URI;

import nbi.xmlsec.xacml.parser.AnyURIMatchParser;
import nbi.xmlsec.xacml.parser.TargetMatchParser;
import nbi.xmlsec.xacml.profile.rbac.RolePolicySetIdentifier;

import com.sun.xacml.ParsingException;
import com.sun.xacml.TargetMatch;

/**
 * Parses an RoleValueIdentifier match value from a target match
 * 
 * @author Lutz Suhrbier
 * @version $Revision: 1.4 $
 * @since
 */

public class RolePolicySetMatchParser extends AnyURIMatchParser {

    /**
     * 
     */
    public RolePolicySetMatchParser() {
        super();
    }
    /**
     * Inits the match parser.
     * 
     * @param targetMatch
     *            The target match to parse.
     */
    public RolePolicySetMatchParser(TargetMatch targetMatch) {
        super(targetMatch);
    }

    /**
     * Get the role value from the target match.
     * @return The {@link RolePolicySetIdentifier RolePolicySetIdentifier} or <code>null</code>.
     * 
     * @see TargetMatchParser#parseMatchValue()
     */
    public Object parseMatchValue() throws ParsingException {
        return (URI)super.parseMatchValue();
    }
}
